<?php

/**
 *
 * 
 *
 * Generated by <a href="http://enunciate.webcohesion.com">Enunciate</a>.
 *
 */
 

namespace Org\Apache\Lens\Api;

/**
 * (no documentation provided)
 */
class SupportedOperations<T extends Object>
{

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $supportedOps;

    /**
     * Constructs a SupportedOperations<T extends Object> from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getSupportedOps()
    {
        return $this->supportedOps;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $supportedOps
     */
    public function setSupportedOps($supportedOps)
    {
        $this->supportedOps = $supportedOps;
    }

    /**
     * Initializes this SupportedOperations<T extends Object> from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of SupportedOperations<T extends Object> from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'supportedOperations') && (empty($xml->namespaceURI)) && (!$xml->isEmptyElement)) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc. in the wrapper
                }
        if (($xml->localName == 'operation') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->supportedOps)) {
                $this->supportedOps = array();
            }
            array_push($this->supportedOps, $child);
            $happened = true;
        }
                $xml->read();
            }
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of SupportedOperations<T extends Object> from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this SupportedOperations<T extends Object> to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'supportedOperations', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this SupportedOperations<T extends Object> to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->supportedOps) {
            $writer->startElementNs(null, 'supportedOperations', null);
            foreach ($this->supportedOps as $i => $x) {
                $writer->startElementNs(null, 'operation', null);
                $writer->text($x);
                $writer->endElement();
            }
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class FailedAttempt
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $driverName;

    /**
     * (no documentation provided)
     *
     * @var double
     */
    private $progress;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $progressMessage;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $errorMessage;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $driverStartTime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $driverFinishTime;

    /**
     * Constructs a FailedAttempt from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDriverName()
    {
        return $this->driverName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $driverName
     */
    public function setDriverName($driverName)
    {
        $this->driverName = $driverName;
    }
    /**
     * (no documentation provided)
     *
     * @return double
     */
    public function getProgress()
    {
        return $this->progress;
    }

    /**
     * (no documentation provided)
     *
     * @param double $progress
     */
    public function setProgress($progress)
    {
        $this->progress = $progress;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getProgressMessage()
    {
        return $this->progressMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string $progressMessage
     */
    public function setProgressMessage($progressMessage)
    {
        $this->progressMessage = $progressMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getErrorMessage()
    {
        return $this->errorMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string $errorMessage
     */
    public function setErrorMessage($errorMessage)
    {
        $this->errorMessage = $errorMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getDriverStartTime()
    {
        return $this->driverStartTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $driverStartTime
     */
    public function setDriverStartTime($driverStartTime)
    {
        $this->driverStartTime = $driverStartTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getDriverFinishTime()
    {
        return $this->driverFinishTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $driverFinishTime
     */
    public function setDriverFinishTime($driverFinishTime)
    {
        $this->driverFinishTime = $driverFinishTime;
    }

    /**
     * Initializes this FailedAttempt from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of FailedAttempt from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'driverName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->driverName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'progress') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->progress = $child;
            $happened = true;
        }
        else if (($xml->localName == 'progressMessage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->progressMessage = $child;
            $happened = true;
        }
        else if (($xml->localName == 'errorMessage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->errorMessage = $child;
            $happened = true;
        }
        else if (($xml->localName == 'driverStartTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->driverStartTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'driverFinishTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->driverFinishTime = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of FailedAttempt from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this FailedAttempt to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'failedAttempt', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this FailedAttempt to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->driverName) {
            $writer->startElementNs(null, 'driverName', null);
            $writer->text($this->driverName);
            $writer->endElement();
        }
        if ($this->progress) {
            $writer->startElementNs(null, 'progress', null);
            $writer->text($this->progress);
            $writer->endElement();
        }
        if ($this->progressMessage) {
            $writer->startElementNs(null, 'progressMessage', null);
            $writer->text($this->progressMessage);
            $writer->endElement();
        }
        if ($this->errorMessage) {
            $writer->startElementNs(null, 'errorMessage', null);
            $writer->text($this->errorMessage);
            $writer->endElement();
        }
        if ($this->driverStartTime) {
            $writer->startElementNs(null, 'driverStartTime', null);
            $writer->text($this->driverStartTime);
            $writer->endElement();
        }
        if ($this->driverFinishTime) {
            $writer->startElementNs(null, 'driverFinishTime', null);
            $writer->text($this->driverFinishTime);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class ResultRow
{

    /**
     * The values.
     *
     * @var mixed
     */
    private $values;

    /**
     * Constructs a ResultRow from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The values.
     *
     * @return mixed
     */
    public function getValues()
    {
        return $this->values;
    }

    /**
     * The values.
     *
     * @param mixed $values
     */
    public function setValues($values)
    {
        $this->values = $values;
    }

    /**
     * Initializes this ResultRow from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ResultRow from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'values') && (empty($xml->namespaceURI)) && (!$xml->isEmptyElement)) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc. in the wrapper
                }
        if (($xml->localName == 'values') && (empty($xml->namespaceURI))) {
            $child = new \SimpleXMLElement($xml);
            if (!isset($this->values)) {
                $this->values = array();
            }
            array_push($this->values, $child);
            $happened = true;
        }
                $xml->read();
            }
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of ResultRow from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this ResultRow to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'resultRow', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this ResultRow to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->values) {
            $writer->startElementNs(null, 'values', null);
            foreach ($this->values as $i => $x) {
                $writer->startElementNs(null, 'values', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class ResultColumn
{

    /**
     * The name.
     *
     * @var string
     */
    private $name;

    /**
     * The type.
     *
     * @var string
     */
    private $type;

    /**
     * Constructs a ResultColumn from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The name.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The name.
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * The type.
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * The type.
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }

    /**
     * Initializes this ResultColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ResultColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'type') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->type = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of ResultColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this ResultColumn to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'resultColumn', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this ResultColumn to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->type) {
            $writer->startElementNs(null, 'type', null);
            $writer->text($this->type);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api;

/**
 * (no documentation provided)
 */
class ToYAMLString
{

    /**
     * Constructs a ToYAMLString from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }


    /**
     * Initializes this ToYAMLString from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ToYAMLString from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of ToYAMLString from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this ToYAMLString to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
    }
}

namespace Org\Apache\Lens\Api;

/**
 * (no documentation provided)
 */
class ToXMLString
{

    /**
     * Constructs a ToXMLString from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }


    /**
     * Initializes this ToXMLString from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ToXMLString from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of ToXMLString from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this ToXMLString to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
    }
}

namespace Org\Apache\Lens\Api\Query\Save;

/**
 * (no documentation provided)
 */
class Parameter
{

    /**
     * Name of the parameter used in the query.
     * It should match the following regex pattern &quot;:[a-zA-Z][a-zA-Z_0-9]&quot;.
     *
     * @var string
     */
    private $name;

    /**
     * Display name of the parameter. Should be used by the UI apps for resolution.
     *
     * @var string
     */
    private $displayName;

    /**
     * The default value that will be used,
     * if the parameter is not supplied with any values while running the query.
     *
     * @var string[]
     */
    private $defaultValue;

    /**
     * Data type of the parameter. Could be number, decimal, string or boolean.
     * The value supplied will be parsed with the corresponding data type.
     *
     * @var string
     */
    private $dataType;

    /**
     * Collection type of the parameter.
     * Depending on the type of expression IN/EQ, it could be a single/multiple collection.
     *
     * @var string
     */
    private $collectionType;

    /**
     * Constructs a Parameter from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * Name of the parameter used in the query.
       * It should match the following regex pattern &quot;:[a-zA-Z][a-zA-Z_0-9]&quot;.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Name of the parameter used in the query.
       * It should match the following regex pattern &quot;:[a-zA-Z][a-zA-Z_0-9]&quot;.
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * Display name of the parameter. Should be used by the UI apps for resolution.
     *
     * @return string
     */
    public function getDisplayName()
    {
        return $this->displayName;
    }

    /**
     * Display name of the parameter. Should be used by the UI apps for resolution.
     *
     * @param string $displayName
     */
    public function setDisplayName($displayName)
    {
        $this->displayName = $displayName;
    }
    /**
     * The default value that will be used,
       * if the parameter is not supplied with any values while running the query.
     *
     * @return string[]
     */
    public function getDefaultValue()
    {
        return $this->defaultValue;
    }

    /**
     * The default value that will be used,
       * if the parameter is not supplied with any values while running the query.
     *
     * @param string[] $defaultValue
     */
    public function setDefaultValue($defaultValue)
    {
        $this->defaultValue = $defaultValue;
    }
    /**
     * Data type of the parameter. Could be number, decimal, string or boolean.
       * The value supplied will be parsed with the corresponding data type.
     *
     * @return string
     */
    public function getDataType()
    {
        return $this->dataType;
    }

    /**
     * Data type of the parameter. Could be number, decimal, string or boolean.
       * The value supplied will be parsed with the corresponding data type.
     *
     * @param string $dataType
     */
    public function setDataType($dataType)
    {
        $this->dataType = $dataType;
    }
    /**
     * Collection type of the parameter.
       * Depending on the type of expression IN/EQ, it could be a single/multiple collection.
     *
     * @return string
     */
    public function getCollectionType()
    {
        return $this->collectionType;
    }

    /**
     * Collection type of the parameter.
       * Depending on the type of expression IN/EQ, it could be a single/multiple collection.
     *
     * @param string $collectionType
     */
    public function setCollectionType($collectionType)
    {
        $this->collectionType = $collectionType;
    }

    /**
     * Initializes this Parameter from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of Parameter from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'displayName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->displayName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'defaultValue') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->defaultValue)) {
                $this->defaultValue = array();
            }
            array_push($this->defaultValue, $child);
            $happened = true;
        }
        else if (($xml->localName == 'dataType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->dataType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'collectionType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->collectionType = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of Parameter from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this Parameter to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'parameter', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this Parameter to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->displayName) {
            $writer->startElementNs(null, 'displayName', null);
            $writer->text($this->displayName);
            $writer->endElement();
        }
        if ($this->defaultValue) {
            foreach ($this->defaultValue as $i => $x) {
                $writer->startElementNs(null, 'defaultValue', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->dataType) {
            $writer->startElementNs(null, 'dataType', null);
            $writer->text($this->dataType);
            $writer->endElement();
        }
        if ($this->collectionType) {
            $writer->startElementNs(null, 'collectionType', null);
            $writer->text($this->collectionType);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query\Save;

/**
 * (no documentation provided)
 */
class ResourceModifiedResponse
{

    /**
     * ID of the affected resource
     *
     * @var integer
     */
    private $id;

    /**
     * The resource type
     *
     * @var string
     */
    private $resource;

    /**
     * The action performed on the reource
     *
     * @var string
     */
    private $status;

    /**
     * Constructs a ResourceModifiedResponse from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * ID of the affected resource
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * ID of the affected resource
     *
     * @param integer $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * The resource type
     *
     * @return string
     */
    public function getResource()
    {
        return $this->resource;
    }

    /**
     * The resource type
     *
     * @param string $resource
     */
    public function setResource($resource)
    {
        $this->resource = $resource;
    }
    /**
     * The action performed on the reource
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * The action performed on the reource
     *
     * @param string $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }

    /**
     * Initializes this ResourceModifiedResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ResourceModifiedResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'id') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->id = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resource') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resource = $child;
            $happened = true;
        }
        else if (($xml->localName == 'status') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->status = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of ResourceModifiedResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this ResourceModifiedResponse to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'resourceModifiedResponse', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this ResourceModifiedResponse to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->id) {
            $writer->startElementNs(null, 'id', null);
            $writer->text($this->id);
            $writer->endElement();
        }
        if ($this->resource) {
            $writer->startElementNs(null, 'resource', null);
            $writer->text($this->resource);
            $writer->endElement();
        }
        if ($this->status) {
            $writer->startElementNs(null, 'status', null);
            $writer->text($this->status);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Result;

/**
 * (no documentation provided)
 */
class NoErrorPayload
{

    /**
     * Constructs a NoErrorPayload from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }


    /**
     * Initializes this NoErrorPayload from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of NoErrorPayload from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of NoErrorPayload from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this NoErrorPayload to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'noErrorPayload', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this NoErrorPayload to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
    }
}

namespace Org\Apache\Lens\Api\Session;

/**
 * (no documentation provided)
 */
class UserSessionInfo
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $handle;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $userName;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Query\QueryHandle[]
     */
    private $activeQueries;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $creationTime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $lastAccessTime;

    /**
     * Constructs a UserSessionInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getHandle()
    {
        return $this->handle;
    }

    /**
     * (no documentation provided)
     *
     * @param string $handle
     */
    public function setHandle($handle)
    {
        $this->handle = $handle;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUserName()
    {
        return $this->userName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $userName
     */
    public function setUserName($userName)
    {
        $this->userName = $userName;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Query\QueryHandle[]
     */
    public function getActiveQueries()
    {
        return $this->activeQueries;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Query\QueryHandle[] $activeQueries
     */
    public function setActiveQueries($activeQueries)
    {
        $this->activeQueries = $activeQueries;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getCreationTime()
    {
        return $this->creationTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $creationTime
     */
    public function setCreationTime($creationTime)
    {
        $this->creationTime = $creationTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getLastAccessTime()
    {
        return $this->lastAccessTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $lastAccessTime
     */
    public function setLastAccessTime($lastAccessTime)
    {
        $this->lastAccessTime = $lastAccessTime;
    }

    /**
     * Initializes this UserSessionInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of UserSessionInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'handle') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->handle = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'activeQueries') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\QueryHandle($xml);
            if (!isset($this->activeQueries)) {
                $this->activeQueries = array();
            }
            array_push($this->activeQueries, $child);
            $happened = true;
        }
        else if (($xml->localName == 'creationTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->creationTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'lastAccessTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->lastAccessTime = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of UserSessionInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this UserSessionInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'userSessionInfo', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this UserSessionInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->handle) {
            $writer->startElementNs(null, 'handle', null);
            $writer->text($this->handle);
            $writer->endElement();
        }
        if ($this->userName) {
            $writer->startElementNs(null, 'userName', null);
            $writer->text($this->userName);
            $writer->endElement();
        }
        if ($this->activeQueries) {
            foreach ($this->activeQueries as $i => $x) {
                $writer->startElementNs(null, 'activeQueries', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->creationTime) {
            $writer->startElementNs(null, 'creationTime', null);
            $writer->text($this->creationTime);
            $writer->endElement();
        }
        if ($this->lastAccessTime) {
            $writer->startElementNs(null, 'lastAccessTime', null);
            $writer->text($this->lastAccessTime);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XCube
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $properties;

    /**
     * Constructs a XCube from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getProperties()
    {
        return $this->properties;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $properties
     */
    public function setProperties($properties)
    {
        $this->properties = $properties;
    }

    /**
     * Initializes this XCube from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XCube from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'properties') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->properties = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XCube from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $this->name = $xml->value;
            return true;
        }
        if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $this->description = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XCube to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->writeAttribute('name', $this->name);
        }
        if ($this->description) {
            $writer->writeAttribute('description', $this->description);
        }
        if ($this->properties) {
            $writer->startElementNs('ns2', 'properties', null);
            $this->properties->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XDimAttributes
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XDimAttribute[]
     */
    private $dimAttribute;

    /**
     * Constructs a XDimAttributes from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XDimAttribute[]
     */
    public function getDimAttribute()
    {
        return $this->dimAttribute;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XDimAttribute[] $dimAttribute
     */
    public function setDimAttribute($dimAttribute)
    {
        $this->dimAttribute = $dimAttribute;
    }

    /**
     * Initializes this XDimAttributes from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XDimAttributes from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'dim_attribute') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XDimAttribute($xml);
            if (!isset($this->dimAttribute)) {
                $this->dimAttribute = array();
            }
            array_push($this->dimAttribute, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XDimAttributes from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XDimAttributes to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->dimAttribute) {
            foreach ($this->dimAttribute as $i => $x) {
                $writer->startElementNs('ns2', 'dim_attribute', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XExprSpec
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $expr;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $startTime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $endTime;

    /**
     * Constructs a XExprSpec from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getExpr()
    {
        return $this->expr;
    }

    /**
     * (no documentation provided)
     *
     * @param string $expr
     */
    public function setExpr($expr)
    {
        $this->expr = $expr;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getStartTime()
    {
        return $this->startTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $startTime
     */
    public function setStartTime($startTime)
    {
        $this->startTime = $startTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getEndTime()
    {
        return $this->endTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $endTime
     */
    public function setEndTime($endTime)
    {
        $this->endTime = $endTime;
    }

    /**
     * Initializes this XExprSpec from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XExprSpec from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of XExprSpec from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'expr') && (empty($xml->namespaceURI))) {
            $this->expr = $xml->value;
            return true;
        }
        if (($xml->localName == 'start_time') && (empty($xml->namespaceURI))) {
            $this->startTime = $xml->value;
            return true;
        }
        if (($xml->localName == 'end_time') && (empty($xml->namespaceURI))) {
            $this->endTime = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XExprSpec to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->expr) {
            $writer->writeAttribute('expr', $this->expr);
        }
        if ($this->startTime) {
            $writer->writeAttribute('start_time', $this->startTime);
        }
        if ($this->endTime) {
            $writer->writeAttribute('end_time', $this->endTime);
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XField
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $displayString;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $tags;

    /**
     * Constructs a XField from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDisplayString()
    {
        return $this->displayString;
    }

    /**
     * (no documentation provided)
     *
     * @param string $displayString
     */
    public function setDisplayString($displayString)
    {
        $this->displayString = $displayString;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getTags()
    {
        return $this->tags;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $tags
     */
    public function setTags($tags)
    {
        $this->tags = $tags;
    }

    /**
     * Initializes this XField from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XField from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'tags') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->tags = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XField from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $this->name = $xml->value;
            return true;
        }
        if (($xml->localName == 'display_string') && (empty($xml->namespaceURI))) {
            $this->displayString = $xml->value;
            return true;
        }
        if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $this->description = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XField to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->writeAttribute('name', $this->name);
        }
        if ($this->displayString) {
            $writer->writeAttribute('display_string', $this->displayString);
        }
        if ($this->description) {
            $writer->writeAttribute('description', $this->description);
        }
        if ($this->tags) {
            $writer->startElementNs('ns2', 'tags', null);
            $this->tags->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XFlattenedColumn
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $tableName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $chainName;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XMeasure
     */
    private $measure;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XExprColumn
     */
    private $expression;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XDimAttribute
     */
    private $dimAttribute;

    /**
     * Constructs a XFlattenedColumn from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getTableName()
    {
        return $this->tableName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $tableName
     */
    public function setTableName($tableName)
    {
        $this->tableName = $tableName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getChainName()
    {
        return $this->chainName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $chainName
     */
    public function setChainName($chainName)
    {
        $this->chainName = $chainName;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XMeasure
     */
    public function getMeasure()
    {
        return $this->measure;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XMeasure $measure
     */
    public function setMeasure($measure)
    {
        $this->measure = $measure;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XExprColumn
     */
    public function getExpression()
    {
        return $this->expression;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XExprColumn $expression
     */
    public function setExpression($expression)
    {
        $this->expression = $expression;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XDimAttribute
     */
    public function getDimAttribute()
    {
        return $this->dimAttribute;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XDimAttribute $dimAttribute
     */
    public function setDimAttribute($dimAttribute)
    {
        $this->dimAttribute = $dimAttribute;
    }

    /**
     * Initializes this XFlattenedColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XFlattenedColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'measure') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XMeasure($xml);
            $this->measure = $child;
            $happened = true;
        }
        else if (($xml->localName == 'expression') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XExprColumn($xml);
            $this->expression = $child;
            $happened = true;
        }
        else if (($xml->localName == 'dim_attribute') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XDimAttribute($xml);
            $this->dimAttribute = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XFlattenedColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'table_name') && (empty($xml->namespaceURI))) {
            $this->tableName = $xml->value;
            return true;
        }
        if (($xml->localName == 'chain_name') && (empty($xml->namespaceURI))) {
            $this->chainName = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XFlattenedColumn to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->tableName) {
            $writer->writeAttribute('table_name', $this->tableName);
        }
        if ($this->chainName) {
            $writer->writeAttribute('chain_name', $this->chainName);
        }
        if ($this->measure) {
            $writer->startElementNs('ns2', 'measure', null);
            $this->measure->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->expression) {
            $writer->startElementNs('ns2', 'expression', null);
            $this->expression->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->dimAttribute) {
            $writer->startElementNs('ns2', 'dim_attribute', null);
            $this->dimAttribute->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XFact
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $cubeName;

    /**
     * Constructs a XFact from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getCubeName()
    {
        return $this->cubeName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $cubeName
     */
    public function setCubeName($cubeName)
    {
        $this->cubeName = $cubeName;
    }

    /**
     * Initializes this XFact from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XFact from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of XFact from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $this->name = $xml->value;
            return true;
        }
        if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $this->description = $xml->value;
            return true;
        }
        if (($xml->localName == 'cube_name') && (empty($xml->namespaceURI))) {
            $this->cubeName = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XFact to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->writeAttribute('name', $this->name);
        }
        if ($this->description) {
            $writer->writeAttribute('description', $this->description);
        }
        if ($this->cubeName) {
            $writer->writeAttribute('cube_name', $this->cubeName);
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XExpressions
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XExprColumn[]
     */
    private $expression;

    /**
     * Constructs a XExpressions from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XExprColumn[]
     */
    public function getExpression()
    {
        return $this->expression;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XExprColumn[] $expression
     */
    public function setExpression($expression)
    {
        $this->expression = $expression;
    }

    /**
     * Initializes this XExpressions from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XExpressions from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'expression') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XExprColumn($xml);
            if (!isset($this->expression)) {
                $this->expression = array();
            }
            array_push($this->expression, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XExpressions from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XExpressions to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->expression) {
            foreach ($this->expression as $i => $x) {
                $writer->startElementNs('ns2', 'expression', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XDimensionTable
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $dimensionName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $tableName;

    /**
     * (no documentation provided)
     *
     * @var double
     */
    private $weight;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XColumns
     */
    private $columns;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $properties;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XStorageTables
     */
    private $storageTables;

    /**
     * Constructs a XDimensionTable from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDimensionName()
    {
        return $this->dimensionName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $dimensionName
     */
    public function setDimensionName($dimensionName)
    {
        $this->dimensionName = $dimensionName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getTableName()
    {
        return $this->tableName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $tableName
     */
    public function setTableName($tableName)
    {
        $this->tableName = $tableName;
    }
    /**
     * (no documentation provided)
     *
     * @return double
     */
    public function getWeight()
    {
        return $this->weight;
    }

    /**
     * (no documentation provided)
     *
     * @param double $weight
     */
    public function setWeight($weight)
    {
        $this->weight = $weight;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XColumns
     */
    public function getColumns()
    {
        return $this->columns;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XColumns $columns
     */
    public function setColumns($columns)
    {
        $this->columns = $columns;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getProperties()
    {
        return $this->properties;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $properties
     */
    public function setProperties($properties)
    {
        $this->properties = $properties;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XStorageTables
     */
    public function getStorageTables()
    {
        return $this->storageTables;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XStorageTables $storageTables
     */
    public function setStorageTables($storageTables)
    {
        $this->storageTables = $storageTables;
    }

    /**
     * Initializes this XDimensionTable from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XDimensionTable from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'columns') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XColumns($xml);
            $this->columns = $child;
            $happened = true;
        }
        else if (($xml->localName == 'properties') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->properties = $child;
            $happened = true;
        }
        else if (($xml->localName == 'storage_tables') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XStorageTables($xml);
            $this->storageTables = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XDimensionTable from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'dimension_name') && (empty($xml->namespaceURI))) {
            $this->dimensionName = $xml->value;
            return true;
        }
        if (($xml->localName == 'table_name') && (empty($xml->namespaceURI))) {
            $this->tableName = $xml->value;
            return true;
        }
        if (($xml->localName == 'weight') && (empty($xml->namespaceURI))) {
            $this->weight = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XDimensionTable to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->dimensionName) {
            $writer->writeAttribute('dimension_name', $this->dimensionName);
        }
        if ($this->tableName) {
            $writer->writeAttribute('table_name', $this->tableName);
        }
        if ($this->weight) {
            $writer->writeAttribute('weight', $this->weight);
        }
        if ($this->columns) {
            $writer->startElementNs('ns2', 'columns', null);
            $this->columns->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->properties) {
            $writer->startElementNs('ns2', 'properties', null);
            $this->properties->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->storageTables) {
            $writer->startElementNs('ns2', 'storage_tables', null);
            $this->storageTables->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XDimension
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XDimAttributes
     */
    private $attributes;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XExpressions
     */
    private $expressions;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XJoinChains
     */
    private $joinChains;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $properties;

    /**
     * Constructs a XDimension from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XDimAttributes
     */
    public function getAttributes()
    {
        return $this->attributes;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XDimAttributes $attributes
     */
    public function setAttributes($attributes)
    {
        $this->attributes = $attributes;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XExpressions
     */
    public function getExpressions()
    {
        return $this->expressions;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XExpressions $expressions
     */
    public function setExpressions($expressions)
    {
        $this->expressions = $expressions;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XJoinChains
     */
    public function getJoinChains()
    {
        return $this->joinChains;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XJoinChains $joinChains
     */
    public function setJoinChains($joinChains)
    {
        $this->joinChains = $joinChains;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getProperties()
    {
        return $this->properties;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $properties
     */
    public function setProperties($properties)
    {
        $this->properties = $properties;
    }

    /**
     * Initializes this XDimension from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XDimension from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'attributes') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XDimAttributes($xml);
            $this->attributes = $child;
            $happened = true;
        }
        else if (($xml->localName == 'expressions') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XExpressions($xml);
            $this->expressions = $child;
            $happened = true;
        }
        else if (($xml->localName == 'join_chains') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XJoinChains($xml);
            $this->joinChains = $child;
            $happened = true;
        }
        else if (($xml->localName == 'properties') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->properties = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XDimension from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $this->name = $xml->value;
            return true;
        }
        if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $this->description = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XDimension to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->writeAttribute('name', $this->name);
        }
        if ($this->description) {
            $writer->writeAttribute('description', $this->description);
        }
        if ($this->attributes) {
            $writer->startElementNs('ns2', 'attributes', null);
            $this->attributes->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->expressions) {
            $writer->startElementNs('ns2', 'expressions', null);
            $this->expressions->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->joinChains) {
            $writer->startElementNs('ns2', 'join_chains', null);
            $this->joinChains->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->properties) {
            $writer->startElementNs('ns2', 'properties', null);
            $this->properties->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XDimAttrNames
{

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $attrName;

    /**
     * Constructs a XDimAttrNames from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getAttrName()
    {
        return $this->attrName;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $attrName
     */
    public function setAttrName($attrName)
    {
        $this->attrName = $attrName;
    }

    /**
     * Initializes this XDimAttrNames from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XDimAttrNames from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'attr_name') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->attrName)) {
                $this->attrName = array();
            }
            array_push($this->attrName, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XDimAttrNames from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XDimAttrNames to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->attrName) {
            foreach ($this->attrName as $i => $x) {
                $writer->startElementNs('ns2', 'attr_name', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XColumns
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XColumn[]
     */
    private $column;

    /**
     * Constructs a XColumns from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XColumn[]
     */
    public function getColumn()
    {
        return $this->column;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XColumn[] $column
     */
    public function setColumn($column)
    {
        $this->column = $column;
    }

    /**
     * Initializes this XColumns from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XColumns from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'column') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XColumn($xml);
            if (!isset($this->column)) {
                $this->column = array();
            }
            array_push($this->column, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XColumns from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XColumns to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->column) {
            foreach ($this->column as $i => $x) {
                $writer->startElementNs('ns2', 'column', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XColumn
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $comment;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $startTime;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $endTime;

    /**
     * Constructs a XColumn from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getComment()
    {
        return $this->comment;
    }

    /**
     * (no documentation provided)
     *
     * @param string $comment
     */
    public function setComment($comment)
    {
        $this->comment = $comment;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getStartTime()
    {
        return $this->startTime;
    }

    /**
     * (no documentation provided)
     *
     * @param string $startTime
     */
    public function setStartTime($startTime)
    {
        $this->startTime = $startTime;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getEndTime()
    {
        return $this->endTime;
    }

    /**
     * (no documentation provided)
     *
     * @param string $endTime
     */
    public function setEndTime($endTime)
    {
        $this->endTime = $endTime;
    }

    /**
     * Initializes this XColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of XColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $this->name = $xml->value;
            return true;
        }
        if (($xml->localName == '_type') && (empty($xml->namespaceURI))) {
            $this->type = $xml->value;
            return true;
        }
        if (($xml->localName == 'comment') && (empty($xml->namespaceURI))) {
            $this->comment = $xml->value;
            return true;
        }
        if (($xml->localName == 'start_time') && (empty($xml->namespaceURI))) {
            $this->startTime = $xml->value;
            return true;
        }
        if (($xml->localName == 'end_time') && (empty($xml->namespaceURI))) {
            $this->endTime = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XColumn to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->writeAttribute('name', $this->name);
        }
        if ($this->type) {
            $writer->writeAttribute('_type', $this->type);
        }
        if ($this->comment) {
            $writer->writeAttribute('comment', $this->comment);
        }
        if ($this->startTime) {
            $writer->writeAttribute('start_time', $this->startTime);
        }
        if ($this->endTime) {
            $writer->writeAttribute('end_time', $this->endTime);
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XChainColumn
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $chainName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $refCol;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $destTable;

    /**
     * Constructs a XChainColumn from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getChainName()
    {
        return $this->chainName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $chainName
     */
    public function setChainName($chainName)
    {
        $this->chainName = $chainName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRefCol()
    {
        return $this->refCol;
    }

    /**
     * (no documentation provided)
     *
     * @param string $refCol
     */
    public function setRefCol($refCol)
    {
        $this->refCol = $refCol;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDestTable()
    {
        return $this->destTable;
    }

    /**
     * (no documentation provided)
     *
     * @param string $destTable
     */
    public function setDestTable($destTable)
    {
        $this->destTable = $destTable;
    }

    /**
     * Initializes this XChainColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XChainColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of XChainColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'chain_name') && (empty($xml->namespaceURI))) {
            $this->chainName = $xml->value;
            return true;
        }
        if (($xml->localName == 'ref_col') && (empty($xml->namespaceURI))) {
            $this->refCol = $xml->value;
            return true;
        }
        if (($xml->localName == 'dest_table') && (empty($xml->namespaceURI))) {
            $this->destTable = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XChainColumn to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->chainName) {
            $writer->writeAttribute('chain_name', $this->chainName);
        }
        if ($this->refCol) {
            $writer->writeAttribute('ref_col', $this->refCol);
        }
        if ($this->destTable) {
            $writer->writeAttribute('dest_table', $this->destTable);
        }
    }
}

namespace Org\Apache\Lens\Api\Result;

/**
 * (no documentation provided)
 */
class NoResultData
{

    /**
     * Constructs a NoResultData from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }


    /**
     * Initializes this NoResultData from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of NoResultData from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of NoResultData from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this NoResultData to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'noResultData', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this NoResultData to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
    }
}

namespace Org\Apache\Lens\Api\Result;

/**
 * (no documentation provided)
 */
class LensErrorTO<PAYLOAD extends Object>
{

    /**
     * (no documentation provided)
     *
     * @var mixed
     */
    private $payload;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Result\LensErrorTO[]
     */
    private $childErrors;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $code;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $message;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $stackTrace;

    /**
     * Constructs a LensErrorTO<PAYLOAD extends Object> from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return mixed
     */
    public function getPayload()
    {
        return $this->payload;
    }

    /**
     * (no documentation provided)
     *
     * @param mixed $payload
     */
    public function setPayload($payload)
    {
        $this->payload = $payload;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Result\LensErrorTO[]
     */
    public function getChildErrors()
    {
        return $this->childErrors;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Result\LensErrorTO[] $childErrors
     */
    public function setChildErrors($childErrors)
    {
        $this->childErrors = $childErrors;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getCode()
    {
        return $this->code;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $code
     */
    public function setCode($code)
    {
        $this->code = $code;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * (no documentation provided)
     *
     * @param string $message
     */
    public function setMessage($message)
    {
        $this->message = $message;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getStackTrace()
    {
        return $this->stackTrace;
    }

    /**
     * (no documentation provided)
     *
     * @param string $stackTrace
     */
    public function setStackTrace($stackTrace)
    {
        $this->stackTrace = $stackTrace;
    }

    /**
     * Initializes this LensErrorTO<PAYLOAD extends Object> from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of LensErrorTO<PAYLOAD extends Object> from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'payload') && (empty($xml->namespaceURI))) {
            $child = new \SimpleXMLElement($xml);
            $this->payload = $child;
            $happened = true;
        }
        else if (($xml->localName == 'childErrors') && (empty($xml->namespaceURI)) && (!$xml->isEmptyElement)) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc. in the wrapper
                }
        if (($xml->localName == 'error') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Result\LensErrorTO($xml);
            if (!isset($this->childErrors)) {
                $this->childErrors = array();
            }
            array_push($this->childErrors, $child);
            $happened = true;
        }
                $xml->read();
            }
            $happened = true;
        }
        else if (($xml->localName == 'code') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->code = $child;
            $happened = true;
        }
        else if (($xml->localName == 'message') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->message = $child;
            $happened = true;
        }
        else if (($xml->localName == 'stackTrace') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->stackTrace = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of LensErrorTO<PAYLOAD extends Object> from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this LensErrorTO<PAYLOAD extends Object> to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->payload) {
            $writer->startElementNs(null, 'payload', null);
            $this->payload->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->childErrors) {
            $writer->startElementNs(null, 'childErrors', null);
            foreach ($this->childErrors as $i => $x) {
                $writer->startElementNs(null, 'error', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
            $writer->endElement();
        }
        if ($this->code) {
            $writer->startElementNs(null, 'code', null);
            $writer->text($this->code);
            $writer->endElement();
        }
        if ($this->message) {
            $writer->startElementNs(null, 'message', null);
            $writer->text($this->message);
            $writer->endElement();
        }
        if ($this->stackTrace) {
            $writer->startElementNs(null, 'stackTrace', null);
            $writer->text($this->stackTrace);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Result;

/**
 * (no documentation provided)
 */
class LensAPIResult<DATA extends Object>
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $apiVersion;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $id;

    /**
     * (no documentation provided)
     *
     * @var mixed
     */
    private $data;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Result\LensErrorTO
     */
    private $lensErrorTO;

    /**
     * Constructs a LensAPIResult<DATA extends Object> from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getApiVersion()
    {
        return $this->apiVersion;
    }

    /**
     * (no documentation provided)
     *
     * @param string $apiVersion
     */
    public function setApiVersion($apiVersion)
    {
        $this->apiVersion = $apiVersion;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * (no documentation provided)
     *
     * @param string $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * (no documentation provided)
     *
     * @return mixed
     */
    public function getData()
    {
        return $this->data;
    }

    /**
     * (no documentation provided)
     *
     * @param mixed $data
     */
    public function setData($data)
    {
        $this->data = $data;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Result\LensErrorTO
     */
    public function getLensErrorTO()
    {
        return $this->lensErrorTO;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Result\LensErrorTO $lensErrorTO
     */
    public function setLensErrorTO($lensErrorTO)
    {
        $this->lensErrorTO = $lensErrorTO;
    }

    /**
     * Initializes this LensAPIResult<DATA extends Object> from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of LensAPIResult<DATA extends Object> from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'apiVersion') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->apiVersion = $child;
            $happened = true;
        }
        else if (($xml->localName == 'id') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->id = $child;
            $happened = true;
        }
        else if (($xml->localName == 'data') && (empty($xml->namespaceURI))) {
            $child = new \SimpleXMLElement($xml);
            $this->data = $child;
            $happened = true;
        }
        else if (($xml->localName == 'error') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Result\LensErrorTO($xml);
            $this->lensErrorTO = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of LensAPIResult<DATA extends Object> from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this LensAPIResult<DATA extends Object> to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'lensAPIResult', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this LensAPIResult<DATA extends Object> to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->apiVersion) {
            $writer->startElementNs(null, 'apiVersion', null);
            $writer->text($this->apiVersion);
            $writer->endElement();
        }
        if ($this->id) {
            $writer->startElementNs(null, 'id', null);
            $writer->text($this->id);
            $writer->endElement();
        }
        if ($this->data) {
            $writer->startElementNs(null, 'data', null);
            $this->data->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->lensErrorTO) {
            $writer->startElementNs(null, 'error', null);
            $this->lensErrorTO->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query\Save;

/**
 * (no documentation provided)
 */
class SavedQuery
{

    /**
     * ID of the saved query (unique)
     *
     * @var integer
     */
    private $id;

    /**
     * Name of the saved query
     *
     * @var string
     */
    private $name;

    /**
     * Description of the saved query
     *
     * @var string
     */
    private $description;

    /**
     * The actual query. Should adhere to HQL syntax
     *
     * @var string
     */
    private $query;

    /**
     * Parameters that are used in the query
     *
     * @var \Org\Apache\Lens\Api\Query\Save\Parameter[]
     */
    private $parameters;

    /**
     * Constructs a SavedQuery from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * ID of the saved query (unique)
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * ID of the saved query (unique)
     *
     * @param integer $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * Name of the saved query
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Name of the saved query
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * Description of the saved query
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Description of the saved query
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * The actual query. Should adhere to HQL syntax
     *
     * @return string
     */
    public function getQuery()
    {
        return $this->query;
    }

    /**
     * The actual query. Should adhere to HQL syntax
     *
     * @param string $query
     */
    public function setQuery($query)
    {
        $this->query = $query;
    }
    /**
     * Parameters that are used in the query
     *
     * @return \Org\Apache\Lens\Api\Query\Save\Parameter[]
     */
    public function getParameters()
    {
        return $this->parameters;
    }

    /**
     * Parameters that are used in the query
     *
     * @param \Org\Apache\Lens\Api\Query\Save\Parameter[] $parameters
     */
    public function setParameters($parameters)
    {
        $this->parameters = $parameters;
    }

    /**
     * Initializes this SavedQuery from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of SavedQuery from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'id') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->id = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'query') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->query = $child;
            $happened = true;
        }
        else if (($xml->localName == 'parameters') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\Save\Parameter($xml);
            if (!isset($this->parameters)) {
                $this->parameters = array();
            }
            array_push($this->parameters, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of SavedQuery from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this SavedQuery to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'savedQuery', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this SavedQuery to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->id) {
            $writer->startElementNs(null, 'id', null);
            $writer->text($this->id);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->query) {
            $writer->startElementNs(null, 'query', null);
            $writer->text($this->query);
            $writer->endElement();
        }
        if ($this->parameters) {
            foreach ($this->parameters as $i => $x) {
                $writer->startElementNs(null, 'parameters', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Query\Save;

/**
 * (no documentation provided)
 */
class ParameterParserResponse
{

    /**
     * Flag that denotes if the query and the parameters are valid
     *
     * @var boolean
     */
    private $valid;

    /**
     * The message
     *
     * @var string
     */
    private $message;

    /**
     * The immutable set of parameters parsed from a parameterised HQL query
     *
     * @var \Org\Apache\Lens\Api\Query\Save\Parameter[]
     */
    private $parameters;

    /**
     * Constructs a ParameterParserResponse from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * Flag that denotes if the query and the parameters are valid
     *
     * @return boolean
     */
    public function getValid()
    {
        return $this->valid;
    }

    /**
     * Flag that denotes if the query and the parameters are valid
     *
     * @param boolean $valid
     */
    public function setValid($valid)
    {
        $this->valid = $valid;
    }
    /**
     * The message
     *
     * @return string
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * The message
     *
     * @param string $message
     */
    public function setMessage($message)
    {
        $this->message = $message;
    }
    /**
     * The immutable set of parameters parsed from a parameterised HQL query
     *
     * @return \Org\Apache\Lens\Api\Query\Save\Parameter[]
     */
    public function getParameters()
    {
        return $this->parameters;
    }

    /**
     * The immutable set of parameters parsed from a parameterised HQL query
     *
     * @param \Org\Apache\Lens\Api\Query\Save\Parameter[] $parameters
     */
    public function setParameters($parameters)
    {
        $this->parameters = $parameters;
    }

    /**
     * Initializes this ParameterParserResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ParameterParserResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'valid') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->valid = $child;
            $happened = true;
        }
        else if (($xml->localName == 'message') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->message = $child;
            $happened = true;
        }
        else if (($xml->localName == 'parameters') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\Save\Parameter($xml);
            if (!isset($this->parameters)) {
                $this->parameters = array();
            }
            array_push($this->parameters, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of ParameterParserResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this ParameterParserResponse to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'parameterParserResponse', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this ParameterParserResponse to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->valid) {
            $writer->startElementNs(null, 'valid', null);
            $writer->text($this->valid);
            $writer->endElement();
        }
        if ($this->message) {
            $writer->startElementNs(null, 'message', null);
            $writer->text($this->message);
            $writer->endElement();
        }
        if ($this->parameters) {
            foreach ($this->parameters as $i => $x) {
                $writer->startElementNs(null, 'parameters', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Query\Save;

/**
 * (no documentation provided)
 */
class ListResponse
{

    /**
     * The starting offset of the result set.
     *
     * @var integer
     */
    private $offsetAppplied;

    /**
     * The total number of queries returned in the current request.
     *
     * @var integer
     */
    private $totalCount;

    /**
     * The queries.
     *
     * @var \Org\Apache\Lens\Api\Query\Save\SavedQuery[]
     */
    private $resoures;

    /**
     * Constructs a ListResponse from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The starting offset of the result set.
     *
     * @return integer
     */
    public function getOffsetAppplied()
    {
        return $this->offsetAppplied;
    }

    /**
     * The starting offset of the result set.
     *
     * @param integer $offsetAppplied
     */
    public function setOffsetAppplied($offsetAppplied)
    {
        $this->offsetAppplied = $offsetAppplied;
    }
    /**
     * The total number of queries returned in the current request.
     *
     * @return integer
     */
    public function getTotalCount()
    {
        return $this->totalCount;
    }

    /**
     * The total number of queries returned in the current request.
     *
     * @param integer $totalCount
     */
    public function setTotalCount($totalCount)
    {
        $this->totalCount = $totalCount;
    }
    /**
     * The queries.
     *
     * @return \Org\Apache\Lens\Api\Query\Save\SavedQuery[]
     */
    public function getResoures()
    {
        return $this->resoures;
    }

    /**
     * The queries.
     *
     * @param \Org\Apache\Lens\Api\Query\Save\SavedQuery[] $resoures
     */
    public function setResoures($resoures)
    {
        $this->resoures = $resoures;
    }

    /**
     * Initializes this ListResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ListResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'offsetAppplied') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->offsetAppplied = $child;
            $happened = true;
        }
        else if (($xml->localName == 'totalCount') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->totalCount = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resoures') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\Save\SavedQuery($xml);
            if (!isset($this->resoures)) {
                $this->resoures = array();
            }
            array_push($this->resoures, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of ListResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this ListResponse to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'listResponse', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this ListResponse to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->offsetAppplied) {
            $writer->startElementNs(null, 'offsetAppplied', null);
            $writer->text($this->offsetAppplied);
            $writer->endElement();
        }
        if ($this->totalCount) {
            $writer->startElementNs(null, 'totalCount', null);
            $writer->text($this->totalCount);
            $writer->endElement();
        }
        if ($this->resoures) {
            foreach ($this->resoures as $i => $x) {
                $writer->startElementNs(null, 'resoures', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XFlattenedColumns
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XFlattenedColumn[]
     */
    private $flattenedColumn;

    /**
     * Constructs a XFlattenedColumns from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XFlattenedColumn[]
     */
    public function getFlattenedColumn()
    {
        return $this->flattenedColumn;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XFlattenedColumn[] $flattenedColumn
     */
    public function setFlattenedColumn($flattenedColumn)
    {
        $this->flattenedColumn = $flattenedColumn;
    }

    /**
     * Initializes this XFlattenedColumns from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XFlattenedColumns from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'flattened_column') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XFlattenedColumn($xml);
            if (!isset($this->flattenedColumn)) {
                $this->flattenedColumn = array();
            }
            array_push($this->flattenedColumn, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XFlattenedColumns from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XFlattenedColumns to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->flattenedColumn) {
            foreach ($this->flattenedColumn as $i => $x) {
                $writer->startElementNs('ns2', 'flattened_column', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XJoinChains
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XJoinChain[]
     */
    private $joinChain;

    /**
     * Constructs a XJoinChains from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XJoinChain[]
     */
    public function getJoinChain()
    {
        return $this->joinChain;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XJoinChain[] $joinChain
     */
    public function setJoinChain($joinChain)
    {
        $this->joinChain = $joinChain;
    }

    /**
     * Initializes this XJoinChains from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XJoinChains from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'join_chain') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XJoinChain($xml);
            if (!isset($this->joinChain)) {
                $this->joinChain = array();
            }
            array_push($this->joinChain, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XJoinChains from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XJoinChains to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->joinChain) {
            foreach ($this->joinChain as $i => $x) {
                $writer->startElementNs('ns2', 'join_chain', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XJoinEdges
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XJoinEdge[]
     */
    private $edge;

    /**
     * Constructs a XJoinEdges from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XJoinEdge[]
     */
    public function getEdge()
    {
        return $this->edge;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XJoinEdge[] $edge
     */
    public function setEdge($edge)
    {
        $this->edge = $edge;
    }

    /**
     * Initializes this XJoinEdges from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XJoinEdges from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'edge') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XJoinEdge($xml);
            if (!isset($this->edge)) {
                $this->edge = array();
            }
            array_push($this->edge, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XJoinEdges from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XJoinEdges to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->edge) {
            foreach ($this->edge as $i => $x) {
                $writer->startElementNs('ns2', 'edge', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XJoinPaths
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XJoinPath[]
     */
    private $path;

    /**
     * Constructs a XJoinPaths from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XJoinPath[]
     */
    public function getPath()
    {
        return $this->path;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XJoinPath[] $path
     */
    public function setPath($path)
    {
        $this->path = $path;
    }

    /**
     * Initializes this XJoinPaths from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XJoinPaths from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'path') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XJoinPath($xml);
            if (!isset($this->path)) {
                $this->path = array();
            }
            array_push($this->path, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XJoinPaths from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XJoinPaths to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->path) {
            foreach ($this->path as $i => $x) {
                $writer->startElementNs('ns2', 'path', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XMeasureNames
{

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $measureName;

    /**
     * Constructs a XMeasureNames from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getMeasureName()
    {
        return $this->measureName;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $measureName
     */
    public function setMeasureName($measureName)
    {
        $this->measureName = $measureName;
    }

    /**
     * Initializes this XMeasureNames from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XMeasureNames from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'measure_name') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->measureName)) {
                $this->measureName = array();
            }
            array_push($this->measureName, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XMeasureNames from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XMeasureNames to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->measureName) {
            foreach ($this->measureName as $i => $x) {
                $writer->startElementNs('ns2', 'measure_name', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XMeasures
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XMeasure[]
     */
    private $measure;

    /**
     * Constructs a XMeasures from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XMeasure[]
     */
    public function getMeasure()
    {
        return $this->measure;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XMeasure[] $measure
     */
    public function setMeasure($measure)
    {
        $this->measure = $measure;
    }

    /**
     * Initializes this XMeasures from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XMeasures from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'measure') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XMeasure($xml);
            if (!isset($this->measure)) {
                $this->measure = array();
            }
            array_push($this->measure, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XMeasures from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XMeasures to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->measure) {
            foreach ($this->measure as $i => $x) {
                $writer->startElementNs('ns2', 'measure', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XPartSpec
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XPartSpecElement[]
     */
    private $partSpecElement;

    /**
     * Constructs a XPartSpec from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XPartSpecElement[]
     */
    public function getPartSpecElement()
    {
        return $this->partSpecElement;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XPartSpecElement[] $partSpecElement
     */
    public function setPartSpecElement($partSpecElement)
    {
        $this->partSpecElement = $partSpecElement;
    }

    /**
     * Initializes this XPartSpec from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XPartSpec from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'part_spec_element') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XPartSpecElement($xml);
            if (!isset($this->partSpecElement)) {
                $this->partSpecElement = array();
            }
            array_push($this->partSpecElement, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XPartSpec from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XPartSpec to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->partSpecElement) {
            foreach ($this->partSpecElement as $i => $x) {
                $writer->startElementNs('ns2', 'part_spec_element', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XPartition
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $factOrDimensionTableName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $location;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $inputFormat;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $outputFormat;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $serdeClassname;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $updatePeriod;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XPartSpec
     */
    private $nonTimePartitionSpec;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XTimePartSpec
     */
    private $timePartitionSpec;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XPartSpec
     */
    private $fullPartitionSpec;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $partitionParameters;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $serdeParameters;

    /**
     * Constructs a XPartition from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getFactOrDimensionTableName()
    {
        return $this->factOrDimensionTableName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $factOrDimensionTableName
     */
    public function setFactOrDimensionTableName($factOrDimensionTableName)
    {
        $this->factOrDimensionTableName = $factOrDimensionTableName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * (no documentation provided)
     *
     * @param string $location
     */
    public function setLocation($location)
    {
        $this->location = $location;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getInputFormat()
    {
        return $this->inputFormat;
    }

    /**
     * (no documentation provided)
     *
     * @param string $inputFormat
     */
    public function setInputFormat($inputFormat)
    {
        $this->inputFormat = $inputFormat;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getOutputFormat()
    {
        return $this->outputFormat;
    }

    /**
     * (no documentation provided)
     *
     * @param string $outputFormat
     */
    public function setOutputFormat($outputFormat)
    {
        $this->outputFormat = $outputFormat;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSerdeClassname()
    {
        return $this->serdeClassname;
    }

    /**
     * (no documentation provided)
     *
     * @param string $serdeClassname
     */
    public function setSerdeClassname($serdeClassname)
    {
        $this->serdeClassname = $serdeClassname;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUpdatePeriod()
    {
        return $this->updatePeriod;
    }

    /**
     * (no documentation provided)
     *
     * @param string $updatePeriod
     */
    public function setUpdatePeriod($updatePeriod)
    {
        $this->updatePeriod = $updatePeriod;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XPartSpec
     */
    public function getNonTimePartitionSpec()
    {
        return $this->nonTimePartitionSpec;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XPartSpec $nonTimePartitionSpec
     */
    public function setNonTimePartitionSpec($nonTimePartitionSpec)
    {
        $this->nonTimePartitionSpec = $nonTimePartitionSpec;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XTimePartSpec
     */
    public function getTimePartitionSpec()
    {
        return $this->timePartitionSpec;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XTimePartSpec $timePartitionSpec
     */
    public function setTimePartitionSpec($timePartitionSpec)
    {
        $this->timePartitionSpec = $timePartitionSpec;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XPartSpec
     */
    public function getFullPartitionSpec()
    {
        return $this->fullPartitionSpec;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XPartSpec $fullPartitionSpec
     */
    public function setFullPartitionSpec($fullPartitionSpec)
    {
        $this->fullPartitionSpec = $fullPartitionSpec;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getPartitionParameters()
    {
        return $this->partitionParameters;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $partitionParameters
     */
    public function setPartitionParameters($partitionParameters)
    {
        $this->partitionParameters = $partitionParameters;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getSerdeParameters()
    {
        return $this->serdeParameters;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $serdeParameters
     */
    public function setSerdeParameters($serdeParameters)
    {
        $this->serdeParameters = $serdeParameters;
    }

    /**
     * Initializes this XPartition from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XPartition from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'non_time_partition_spec') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XPartSpec($xml);
            $this->nonTimePartitionSpec = $child;
            $happened = true;
        }
        else if (($xml->localName == 'time_partition_spec') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XTimePartSpec($xml);
            $this->timePartitionSpec = $child;
            $happened = true;
        }
        else if (($xml->localName == 'full_partition_spec') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XPartSpec($xml);
            $this->fullPartitionSpec = $child;
            $happened = true;
        }
        else if (($xml->localName == 'partition_parameters') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->partitionParameters = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serde_parameters') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->serdeParameters = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XPartition from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'fact_or_dimension_table_name') && (empty($xml->namespaceURI))) {
            $this->factOrDimensionTableName = $xml->value;
            return true;
        }
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $this->name = $xml->value;
            return true;
        }
        if (($xml->localName == 'location') && (empty($xml->namespaceURI))) {
            $this->location = $xml->value;
            return true;
        }
        if (($xml->localName == 'input_format') && (empty($xml->namespaceURI))) {
            $this->inputFormat = $xml->value;
            return true;
        }
        if (($xml->localName == 'output_format') && (empty($xml->namespaceURI))) {
            $this->outputFormat = $xml->value;
            return true;
        }
        if (($xml->localName == 'serde_classname') && (empty($xml->namespaceURI))) {
            $this->serdeClassname = $xml->value;
            return true;
        }
        if (($xml->localName == 'update_period') && (empty($xml->namespaceURI))) {
            $this->updatePeriod = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XPartition to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->factOrDimensionTableName) {
            $writer->writeAttribute('fact_or_dimension_table_name', $this->factOrDimensionTableName);
        }
        if ($this->name) {
            $writer->writeAttribute('name', $this->name);
        }
        if ($this->location) {
            $writer->writeAttribute('location', $this->location);
        }
        if ($this->inputFormat) {
            $writer->writeAttribute('input_format', $this->inputFormat);
        }
        if ($this->outputFormat) {
            $writer->writeAttribute('output_format', $this->outputFormat);
        }
        if ($this->serdeClassname) {
            $writer->writeAttribute('serde_classname', $this->serdeClassname);
        }
        if ($this->updatePeriod) {
            $writer->writeAttribute('update_period', $this->updatePeriod);
        }
        if ($this->nonTimePartitionSpec) {
            $writer->startElementNs('ns2', 'non_time_partition_spec', null);
            $this->nonTimePartitionSpec->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->timePartitionSpec) {
            $writer->startElementNs('ns2', 'time_partition_spec', null);
            $this->timePartitionSpec->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->fullPartitionSpec) {
            $writer->startElementNs('ns2', 'full_partition_spec', null);
            $this->fullPartitionSpec->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->partitionParameters) {
            $writer->startElementNs('ns2', 'partition_parameters', null);
            $this->partitionParameters->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->serdeParameters) {
            $writer->startElementNs('ns2', 'serde_parameters', null);
            $this->serdeParameters->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XProperties
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperty[]
     */
    private $property;

    /**
     * Constructs a XProperties from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperty[]
     */
    public function getProperty()
    {
        return $this->property;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperty[] $property
     */
    public function setProperty($property)
    {
        $this->property = $property;
    }

    /**
     * Initializes this XProperties from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XProperties from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'property') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperty($xml);
            if (!isset($this->property)) {
                $this->property = array();
            }
            array_push($this->property, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XProperties from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XProperties to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->property) {
            foreach ($this->property as $i => $x) {
                $writer->startElementNs('ns2', 'property', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XSegment
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $cubeName;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $segmentParameters;

    /**
     * Constructs a XSegment from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getCubeName()
    {
        return $this->cubeName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $cubeName
     */
    public function setCubeName($cubeName)
    {
        $this->cubeName = $cubeName;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getSegmentParameters()
    {
        return $this->segmentParameters;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $segmentParameters
     */
    public function setSegmentParameters($segmentParameters)
    {
        $this->segmentParameters = $segmentParameters;
    }

    /**
     * Initializes this XSegment from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XSegment from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'segment_parameters') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->segmentParameters = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XSegment from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'cube_name') && (empty($xml->namespaceURI))) {
            $this->cubeName = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XSegment to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->cubeName) {
            $writer->writeAttribute('cube_name', $this->cubeName);
        }
        if ($this->segmentParameters) {
            $writer->startElementNs('ns2', 'segment_parameters', null);
            $this->segmentParameters->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XSegments
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XSegment[]
     */
    private $segment;

    /**
     * Constructs a XSegments from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XSegment[]
     */
    public function getSegment()
    {
        return $this->segment;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XSegment[] $segment
     */
    public function setSegment($segment)
    {
        $this->segment = $segment;
    }

    /**
     * Initializes this XSegments from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XSegments from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'segment') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XSegment($xml);
            if (!isset($this->segment)) {
                $this->segment = array();
            }
            array_push($this->segment, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XSegments from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XSegments to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->segment) {
            foreach ($this->segment as $i => $x) {
                $writer->startElementNs('ns2', 'segment', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XSkewedInfo
{

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $colNames;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XSkewColList[]
     */
    private $colValues;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XSkewedValueLocation[]
     */
    private $valueLocationMap;

    /**
     * Constructs a XSkewedInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getColNames()
    {
        return $this->colNames;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $colNames
     */
    public function setColNames($colNames)
    {
        $this->colNames = $colNames;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XSkewColList[]
     */
    public function getColValues()
    {
        return $this->colValues;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XSkewColList[] $colValues
     */
    public function setColValues($colValues)
    {
        $this->colValues = $colValues;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XSkewedValueLocation[]
     */
    public function getValueLocationMap()
    {
        return $this->valueLocationMap;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XSkewedValueLocation[] $valueLocationMap
     */
    public function setValueLocationMap($valueLocationMap)
    {
        $this->valueLocationMap = $valueLocationMap;
    }

    /**
     * Initializes this XSkewedInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XSkewedInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'col_names') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->colNames)) {
                $this->colNames = array();
            }
            array_push($this->colNames, $child);
            $happened = true;
        }
        else if (($xml->localName == 'col_values') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XSkewColList($xml);
            if (!isset($this->colValues)) {
                $this->colValues = array();
            }
            array_push($this->colValues, $child);
            $happened = true;
        }
        else if (($xml->localName == 'value_location_map') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XSkewedValueLocation($xml);
            if (!isset($this->valueLocationMap)) {
                $this->valueLocationMap = array();
            }
            array_push($this->valueLocationMap, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XSkewedInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XSkewedInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->colNames) {
            foreach ($this->colNames as $i => $x) {
                $writer->startElementNs('ns2', 'col_names', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->colValues) {
            foreach ($this->colValues as $i => $x) {
                $writer->startElementNs('ns2', 'col_values', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->valueLocationMap) {
            foreach ($this->valueLocationMap as $i => $x) {
                $writer->startElementNs('ns2', 'value_location_map', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XStorage
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $classname;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $properties;

    /**
     * Constructs a XStorage from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getClassname()
    {
        return $this->classname;
    }

    /**
     * (no documentation provided)
     *
     * @param string $classname
     */
    public function setClassname($classname)
    {
        $this->classname = $classname;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getProperties()
    {
        return $this->properties;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $properties
     */
    public function setProperties($properties)
    {
        $this->properties = $properties;
    }

    /**
     * Initializes this XStorage from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XStorage from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'properties') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->properties = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XStorage from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $this->name = $xml->value;
            return true;
        }
        if (($xml->localName == 'classname') && (empty($xml->namespaceURI))) {
            $this->classname = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XStorage to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->writeAttribute('name', $this->name);
        }
        if ($this->classname) {
            $writer->writeAttribute('classname', $this->classname);
        }
        if ($this->properties) {
            $writer->startElementNs('ns2', 'properties', null);
            $this->properties->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XStorageTableElement
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XUpdatePeriods
     */
    private $updatePeriods;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $storageName;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XStorageTableDesc
     */
    private $tableDesc;

    /**
     * Constructs a XStorageTableElement from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XUpdatePeriods
     */
    public function getUpdatePeriods()
    {
        return $this->updatePeriods;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XUpdatePeriods $updatePeriods
     */
    public function setUpdatePeriods($updatePeriods)
    {
        $this->updatePeriods = $updatePeriods;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getStorageName()
    {
        return $this->storageName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $storageName
     */
    public function setStorageName($storageName)
    {
        $this->storageName = $storageName;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XStorageTableDesc
     */
    public function getTableDesc()
    {
        return $this->tableDesc;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XStorageTableDesc $tableDesc
     */
    public function setTableDesc($tableDesc)
    {
        $this->tableDesc = $tableDesc;
    }

    /**
     * Initializes this XStorageTableElement from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XStorageTableElement from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'update_periods') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XUpdatePeriods($xml);
            $this->updatePeriods = $child;
            $happened = true;
        }
        else if (($xml->localName == 'storage_name') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->storageName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'table_desc') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XStorageTableDesc($xml);
            $this->tableDesc = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XStorageTableElement from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XStorageTableElement to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->updatePeriods) {
            $writer->startElementNs('ns2', 'update_periods', null);
            $this->updatePeriods->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->storageName) {
            $writer->startElementNs('ns2', 'storage_name', null);
            $writer->text($this->storageName);
            $writer->endElement();
        }
        if ($this->tableDesc) {
            $writer->startElementNs('ns2', 'table_desc', null);
            $this->tableDesc->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XTableReference
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $table;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $column;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $mapsToMany;

    /**
     * Constructs a XTableReference from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getTable()
    {
        return $this->table;
    }

    /**
     * (no documentation provided)
     *
     * @param string $table
     */
    public function setTable($table)
    {
        $this->table = $table;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getColumn()
    {
        return $this->column;
    }

    /**
     * (no documentation provided)
     *
     * @param string $column
     */
    public function setColumn($column)
    {
        $this->column = $column;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getMapsToMany()
    {
        return $this->mapsToMany;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $mapsToMany
     */
    public function setMapsToMany($mapsToMany)
    {
        $this->mapsToMany = $mapsToMany;
    }

    /**
     * Initializes this XTableReference from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XTableReference from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of XTableReference from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'table') && (empty($xml->namespaceURI))) {
            $this->table = $xml->value;
            return true;
        }
        if (($xml->localName == 'column') && (empty($xml->namespaceURI))) {
            $this->column = $xml->value;
            return true;
        }
        if (($xml->localName == 'maps_to_many') && (empty($xml->namespaceURI))) {
            $this->mapsToMany = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XTableReference to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->table) {
            $writer->writeAttribute('table', $this->table);
        }
        if ($this->column) {
            $writer->writeAttribute('column', $this->column);
        }
        if ($this->mapsToMany) {
            $writer->writeAttribute('maps_to_many', $this->mapsToMany);
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XTimePartSpecElement
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $key;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $value;

    /**
     * Constructs a XTimePartSpecElement from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getKey()
    {
        return $this->key;
    }

    /**
     * (no documentation provided)
     *
     * @param string $key
     */
    public function setKey($key)
    {
        $this->key = $key;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getValue()
    {
        return $this->value;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $value
     */
    public function setValue($value)
    {
        $this->value = $value;
    }

    /**
     * Initializes this XTimePartSpecElement from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XTimePartSpecElement from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of XTimePartSpecElement from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'key') && (empty($xml->namespaceURI))) {
            $this->key = $xml->value;
            return true;
        }
        if (($xml->localName == 'value') && (empty($xml->namespaceURI))) {
            $this->value = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XTimePartSpecElement to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->key) {
            $writer->writeAttribute('key', $this->key);
        }
        if ($this->value) {
            $writer->writeAttribute('value', $this->value);
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XUpdatePeriodTableDescriptor
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $updatePeriod;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XStorageTableDesc
     */
    private $tableDesc;

    /**
     * Constructs a XUpdatePeriodTableDescriptor from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUpdatePeriod()
    {
        return $this->updatePeriod;
    }

    /**
     * (no documentation provided)
     *
     * @param string $updatePeriod
     */
    public function setUpdatePeriod($updatePeriod)
    {
        $this->updatePeriod = $updatePeriod;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XStorageTableDesc
     */
    public function getTableDesc()
    {
        return $this->tableDesc;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XStorageTableDesc $tableDesc
     */
    public function setTableDesc($tableDesc)
    {
        $this->tableDesc = $tableDesc;
    }

    /**
     * Initializes this XUpdatePeriodTableDescriptor from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XUpdatePeriodTableDescriptor from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'update_period') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->updatePeriod = $child;
            $happened = true;
        }
        else if (($xml->localName == 'table_desc') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XStorageTableDesc($xml);
            $this->tableDesc = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XUpdatePeriodTableDescriptor from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XUpdatePeriodTableDescriptor to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->updatePeriod) {
            $writer->startElementNs('ns2', 'update_period', null);
            $writer->text($this->updatePeriod);
            $writer->endElement();
        }
        if ($this->tableDesc) {
            $writer->startElementNs('ns2', 'table_desc', null);
            $this->tableDesc->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XUpdatePeriods
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XUpdatePeriodTableDescriptor[]
     */
    private $updatePeriodTableDescriptor;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $updatePeriod;

    /**
     * Constructs a XUpdatePeriods from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XUpdatePeriodTableDescriptor[]
     */
    public function getUpdatePeriodTableDescriptor()
    {
        return $this->updatePeriodTableDescriptor;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XUpdatePeriodTableDescriptor[] $updatePeriodTableDescriptor
     */
    public function setUpdatePeriodTableDescriptor($updatePeriodTableDescriptor)
    {
        $this->updatePeriodTableDescriptor = $updatePeriodTableDescriptor;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getUpdatePeriod()
    {
        return $this->updatePeriod;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $updatePeriod
     */
    public function setUpdatePeriod($updatePeriod)
    {
        $this->updatePeriod = $updatePeriod;
    }

    /**
     * Initializes this XUpdatePeriods from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XUpdatePeriods from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'update_period_table_descriptor') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XUpdatePeriodTableDescriptor($xml);
            if (!isset($this->updatePeriodTableDescriptor)) {
                $this->updatePeriodTableDescriptor = array();
            }
            array_push($this->updatePeriodTableDescriptor, $child);
            $happened = true;
        }
        else if (($xml->localName == 'update_period') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->updatePeriod)) {
                $this->updatePeriod = array();
            }
            array_push($this->updatePeriod, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XUpdatePeriods from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XUpdatePeriods to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->updatePeriodTableDescriptor) {
            foreach ($this->updatePeriodTableDescriptor as $i => $x) {
                $writer->startElementNs('ns2', 'update_period_table_descriptor', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->updatePeriod) {
            foreach ($this->updatePeriod as $i => $x) {
                $writer->startElementNs('ns2', 'update_period', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class ResourcePath
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $path;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * Constructs a ResourcePath from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getPath()
    {
        return $this->path;
    }

    /**
     * (no documentation provided)
     *
     * @param string $path
     */
    public function setPath($path)
    {
        $this->path = $path;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }

    /**
     * Initializes this ResourcePath from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ResourcePath from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'path') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->path = $child;
            $happened = true;
        }
        else if (($xml->localName == 'type') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->type = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of ResourcePath from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this ResourcePath to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->path) {
            $writer->startElementNs('ns1', 'path', null);
            $writer->text($this->path);
            $writer->endElement();
        }
        if ($this->type) {
            $writer->startElementNs('ns1', 'type', null);
            $writer->text($this->type);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class SchedulerJobInfo
{

    /**
     * ID for the current job.
     *
     * @var \Org\Apache\Lens\Api\Scheduler\SchedulerJobHandle
     */
    private $id;

    /**
     * Definition of the job scheduled.
     *
     * @var \Org\Apache\Lens\Api\Scheduler\XJob
     */
    private $job;

    /**
     * name of the user who scheduled this job.
     *
     * @var string
     */
    private $userName;

    /**
     * current status of this job
     *
     * @var string
     */
    private $jobState;

    /**
     * time when this job was submitted.
     *
     * @var integer
     */
    private $createdOn;

    /**
     * last modified time for this job
     *
     * @var integer
     */
    private $modifiedOn;

    /**
     * Constructs a SchedulerJobInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * ID for the current job.
     *
     * @return \Org\Apache\Lens\Api\Scheduler\SchedulerJobHandle
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * ID for the current job.
     *
     * @param \Org\Apache\Lens\Api\Scheduler\SchedulerJobHandle $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * Definition of the job scheduled.
     *
     * @return \Org\Apache\Lens\Api\Scheduler\XJob
     */
    public function getJob()
    {
        return $this->job;
    }

    /**
     * Definition of the job scheduled.
     *
     * @param \Org\Apache\Lens\Api\Scheduler\XJob $job
     */
    public function setJob($job)
    {
        $this->job = $job;
    }
    /**
     * name of the user who scheduled this job.
     *
     * @return string
     */
    public function getUserName()
    {
        return $this->userName;
    }

    /**
     * name of the user who scheduled this job.
     *
     * @param string $userName
     */
    public function setUserName($userName)
    {
        $this->userName = $userName;
    }
    /**
     * current status of this job
     *
     * @return string
     */
    public function getJobState()
    {
        return $this->jobState;
    }

    /**
     * current status of this job
     *
     * @param string $jobState
     */
    public function setJobState($jobState)
    {
        $this->jobState = $jobState;
    }
    /**
     * time when this job was submitted.
     *
     * @return integer
     */
    public function getCreatedOn()
    {
        return $this->createdOn;
    }

    /**
     * time when this job was submitted.
     *
     * @param integer $createdOn
     */
    public function setCreatedOn($createdOn)
    {
        $this->createdOn = $createdOn;
    }
    /**
     * last modified time for this job
     *
     * @return integer
     */
    public function getModifiedOn()
    {
        return $this->modifiedOn;
    }

    /**
     * last modified time for this job
     *
     * @param integer $modifiedOn
     */
    public function setModifiedOn($modifiedOn)
    {
        $this->modifiedOn = $modifiedOn;
    }

    /**
     * Initializes this SchedulerJobInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of SchedulerJobInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'id') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\SchedulerJobHandle($xml);
            $this->id = $child;
            $happened = true;
        }
        else if (($xml->localName == 'job') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\XJob($xml);
            $this->job = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userName') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'jobState') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->jobState = $child;
            $happened = true;
        }
        else if (($xml->localName == 'createdOn') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->createdOn = $child;
            $happened = true;
        }
        else if (($xml->localName == 'modifiedOn') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->modifiedOn = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of SchedulerJobInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this SchedulerJobInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS('ns1', 'schedulerJobInfo', null);
        if ($includeNamespaces) {
            $writer->writeAttributeNs('xmlns', 'ns1', null, 'uri:lens:job:0.1');
        }
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this SchedulerJobInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->id) {
            $writer->startElementNs('ns1', 'id', null);
            $this->id->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->job) {
            $writer->startElementNs('ns1', 'job', null);
            $this->job->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->userName) {
            $writer->startElementNs('ns1', 'userName', null);
            $writer->text($this->userName);
            $writer->endElement();
        }
        if ($this->jobState) {
            $writer->startElementNs('ns1', 'jobState', null);
            $writer->text($this->jobState);
            $writer->endElement();
        }
        if ($this->createdOn) {
            $writer->startElementNs('ns1', 'createdOn', null);
            $writer->text($this->createdOn);
            $writer->endElement();
        }
        if ($this->modifiedOn) {
            $writer->startElementNs('ns1', 'modifiedOn', null);
            $writer->text($this->modifiedOn);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class SchedulerJobInstanceInfo
{

    /**
     * unique id for this instance of scheduler job.
     *
     * @var \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceHandle
     */
    private $id;

    /**
     * id for the scheduler job to which this instance belongs.
     *
     * @var \Org\Apache\Lens\Api\Scheduler\SchedulerJobHandle
     */
    private $jobId;

    /**
     * scheduled time of this instance.
     *
     * @var integer
     */
    private $scheduleTime;

    /**
     * A list of instance-run for this instance.
     *
     * @var \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceRun[]
     */
    private $instanceRunList;

    /**
     * Constructs a SchedulerJobInstanceInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * unique id for this instance of scheduler job.
     *
     * @return \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceHandle
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * unique id for this instance of scheduler job.
     *
     * @param \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceHandle $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * id for the scheduler job to which this instance belongs.
     *
     * @return \Org\Apache\Lens\Api\Scheduler\SchedulerJobHandle
     */
    public function getJobId()
    {
        return $this->jobId;
    }

    /**
     * id for the scheduler job to which this instance belongs.
     *
     * @param \Org\Apache\Lens\Api\Scheduler\SchedulerJobHandle $jobId
     */
    public function setJobId($jobId)
    {
        $this->jobId = $jobId;
    }
    /**
     * scheduled time of this instance.
     *
     * @return integer
     */
    public function getScheduleTime()
    {
        return $this->scheduleTime;
    }

    /**
     * scheduled time of this instance.
     *
     * @param integer $scheduleTime
     */
    public function setScheduleTime($scheduleTime)
    {
        $this->scheduleTime = $scheduleTime;
    }
    /**
     * A list of instance-run for this instance.
     *
     * @return \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceRun[]
     */
    public function getInstanceRunList()
    {
        return $this->instanceRunList;
    }

    /**
     * A list of instance-run for this instance.
     *
     * @param \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceRun[] $instanceRunList
     */
    public function setInstanceRunList($instanceRunList)
    {
        $this->instanceRunList = $instanceRunList;
    }

    /**
     * Initializes this SchedulerJobInstanceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of SchedulerJobInstanceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'id') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceHandle($xml);
            $this->id = $child;
            $happened = true;
        }
        else if (($xml->localName == 'jobId') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\SchedulerJobHandle($xml);
            $this->jobId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'scheduleTime') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->scheduleTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'instanceRunList') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceRun($xml);
            if (!isset($this->instanceRunList)) {
                $this->instanceRunList = array();
            }
            array_push($this->instanceRunList, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of SchedulerJobInstanceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this SchedulerJobInstanceInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS('ns1', 'schedulerJobInstanceInfo', null);
        if ($includeNamespaces) {
            $writer->writeAttributeNs('xmlns', 'ns1', null, 'uri:lens:job:0.1');
        }
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this SchedulerJobInstanceInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->id) {
            $writer->startElementNs('ns1', 'id', null);
            $this->id->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->jobId) {
            $writer->startElementNs('ns1', 'jobId', null);
            $this->jobId->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->scheduleTime) {
            $writer->startElementNs('ns1', 'scheduleTime', null);
            $writer->text($this->scheduleTime);
            $writer->endElement();
        }
        if ($this->instanceRunList) {
            foreach ($this->instanceRunList as $i => $x) {
                $writer->startElementNs('ns1', 'instanceRunList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class SchedulerJobInstanceRun
{

    /**
     * the handle
     *
     * @var \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceHandle
     */
    private $handle;

    /**
     * the runId
     *
     * @var integer
     */
    private $runId;

    /**
     * session handle for this instance run.
     *
     * @var \Org\Apache\Lens\Api\LensSessionHandle
     */
    private $sessionHandle;

    /**
     * actual start time of this instance run .
     *
     * @var integer
     */
    private $startTime;

    /**
     * actual finish time of this instance run.
     *
     * @var integer
     */
    private $endTime;

    /**
     * result path of this instance run.
     *
     * @var string
     */
    private $resultPath;

    /**
     * queryHandle of this instance run.
     *
     * @var \Org\Apache\Lens\Api\Query\QueryHandle
     */
    private $queryHandle;

    /**
     * status of this instance.
     *
     * @var string
     */
    private $instanceState;

    /**
     * Constructs a SchedulerJobInstanceRun from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * the handle
     *
     * @return \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceHandle
     */
    public function getHandle()
    {
        return $this->handle;
    }

    /**
     * the handle
     *
     * @param \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceHandle $handle
     */
    public function setHandle($handle)
    {
        $this->handle = $handle;
    }
    /**
     * the runId
     *
     * @return integer
     */
    public function getRunId()
    {
        return $this->runId;
    }

    /**
     * the runId
     *
     * @param integer $runId
     */
    public function setRunId($runId)
    {
        $this->runId = $runId;
    }
    /**
     * session handle for this instance run.
     *
     * @return \Org\Apache\Lens\Api\LensSessionHandle
     */
    public function getSessionHandle()
    {
        return $this->sessionHandle;
    }

    /**
     * session handle for this instance run.
     *
     * @param \Org\Apache\Lens\Api\LensSessionHandle $sessionHandle
     */
    public function setSessionHandle($sessionHandle)
    {
        $this->sessionHandle = $sessionHandle;
    }
    /**
     * actual start time of this instance run .
     *
     * @return integer
     */
    public function getStartTime()
    {
        return $this->startTime;
    }

    /**
     * actual start time of this instance run .
     *
     * @param integer $startTime
     */
    public function setStartTime($startTime)
    {
        $this->startTime = $startTime;
    }
    /**
     * actual finish time of this instance run.
     *
     * @return integer
     */
    public function getEndTime()
    {
        return $this->endTime;
    }

    /**
     * actual finish time of this instance run.
     *
     * @param integer $endTime
     */
    public function setEndTime($endTime)
    {
        $this->endTime = $endTime;
    }
    /**
     * result path of this instance run.
     *
     * @return string
     */
    public function getResultPath()
    {
        return $this->resultPath;
    }

    /**
     * result path of this instance run.
     *
     * @param string $resultPath
     */
    public function setResultPath($resultPath)
    {
        $this->resultPath = $resultPath;
    }
    /**
     * queryHandle of this instance run.
     *
     * @return \Org\Apache\Lens\Api\Query\QueryHandle
     */
    public function getQueryHandle()
    {
        return $this->queryHandle;
    }

    /**
     * queryHandle of this instance run.
     *
     * @param \Org\Apache\Lens\Api\Query\QueryHandle $queryHandle
     */
    public function setQueryHandle($queryHandle)
    {
        $this->queryHandle = $queryHandle;
    }
    /**
     * status of this instance.
     *
     * @return string
     */
    public function getInstanceState()
    {
        return $this->instanceState;
    }

    /**
     * status of this instance.
     *
     * @param string $instanceState
     */
    public function setInstanceState($instanceState)
    {
        $this->instanceState = $instanceState;
    }

    /**
     * Initializes this SchedulerJobInstanceRun from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of SchedulerJobInstanceRun from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'handle') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\SchedulerJobInstanceHandle($xml);
            $this->handle = $child;
            $happened = true;
        }
        else if (($xml->localName == 'runId') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->runId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'sessionHandle') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\LensSessionHandle($xml);
            $this->sessionHandle = $child;
            $happened = true;
        }
        else if (($xml->localName == 'startTime') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->startTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'endTime') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->endTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resultPath') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resultPath = $child;
            $happened = true;
        }
        else if (($xml->localName == 'queryHandle') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Query\QueryHandle($xml);
            $this->queryHandle = $child;
            $happened = true;
        }
        else if (($xml->localName == 'instanceState') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->instanceState = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of SchedulerJobInstanceRun from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this SchedulerJobInstanceRun to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS('ns1', 'schedulerJobInstanceRun', null);
        if ($includeNamespaces) {
            $writer->writeAttributeNs('xmlns', 'ns1', null, 'uri:lens:job:0.1');
        }
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this SchedulerJobInstanceRun to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->handle) {
            $writer->startElementNs('ns1', 'handle', null);
            $this->handle->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->runId) {
            $writer->startElementNs('ns1', 'runId', null);
            $writer->text($this->runId);
            $writer->endElement();
        }
        if ($this->sessionHandle) {
            $writer->startElementNs('ns1', 'sessionHandle', null);
            $this->sessionHandle->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->startTime) {
            $writer->startElementNs('ns1', 'startTime', null);
            $writer->text($this->startTime);
            $writer->endElement();
        }
        if ($this->endTime) {
            $writer->startElementNs('ns1', 'endTime', null);
            $writer->text($this->endTime);
            $writer->endElement();
        }
        if ($this->resultPath) {
            $writer->startElementNs('ns1', 'resultPath', null);
            $writer->text($this->resultPath);
            $writer->endElement();
        }
        if ($this->queryHandle) {
            $writer->startElementNs('ns1', 'queryHandle', null);
            $this->queryHandle->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->instanceState) {
            $writer->startElementNs('ns1', 'instanceState', null);
            $writer->text($this->instanceState);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class SchedulerJobStats
{

    /**
     * Constructs a SchedulerJobStats from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }


    /**
     * Initializes this SchedulerJobStats from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of SchedulerJobStats from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of SchedulerJobStats from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this SchedulerJobStats to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class XFrequency
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $timezone;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $_enum;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $cronExpression;

    /**
     * Constructs a XFrequency from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getTimezone()
    {
        return $this->timezone;
    }

    /**
     * (no documentation provided)
     *
     * @param string $timezone
     */
    public function setTimezone($timezone)
    {
        $this->timezone = $timezone;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function get_enum()
    {
        return $this->_enum;
    }

    /**
     * (no documentation provided)
     *
     * @param string $_enum
     */
    public function set_enum($_enum)
    {
        $this->_enum = $_enum;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getCronExpression()
    {
        return $this->cronExpression;
    }

    /**
     * (no documentation provided)
     *
     * @param string $cronExpression
     */
    public function setCronExpression($cronExpression)
    {
        $this->cronExpression = $cronExpression;
    }

    /**
     * Initializes this XFrequency from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XFrequency from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'enum') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->_enum = $child;
            $happened = true;
        }
        else if (($xml->localName == 'cron_expression') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->cronExpression = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XFrequency from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'timezone') && (empty($xml->namespaceURI))) {
            $this->timezone = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XFrequency to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->timezone) {
            $writer->writeAttribute('timezone', $this->timezone);
        }
        if ($this->_enum) {
            $writer->startElementNs('ns1', 'enum', null);
            $writer->text($this->_enum);
            $writer->endElement();
        }
        if ($this->cronExpression) {
            $writer->startElementNs('ns1', 'cron_expression', null);
            $writer->text($this->cronExpression);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class XJob
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Scheduler\XExecution
     */
    private $execution;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Scheduler\XTrigger
     */
    private $trigger;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Scheduler\MapType[]
     */
    private $jobConf;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $startTime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $endTime;

    /**
     * Constructs a XJob from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Scheduler\XExecution
     */
    public function getExecution()
    {
        return $this->execution;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Scheduler\XExecution $execution
     */
    public function setExecution($execution)
    {
        $this->execution = $execution;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Scheduler\XTrigger
     */
    public function getTrigger()
    {
        return $this->trigger;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Scheduler\XTrigger $trigger
     */
    public function setTrigger($trigger)
    {
        $this->trigger = $trigger;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Scheduler\MapType[]
     */
    public function getJobConf()
    {
        return $this->jobConf;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Scheduler\MapType[] $jobConf
     */
    public function setJobConf($jobConf)
    {
        $this->jobConf = $jobConf;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getStartTime()
    {
        return $this->startTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $startTime
     */
    public function setStartTime($startTime)
    {
        $this->startTime = $startTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getEndTime()
    {
        return $this->endTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $endTime
     */
    public function setEndTime($endTime)
    {
        $this->endTime = $endTime;
    }

    /**
     * Initializes this XJob from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XJob from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'name') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'execution') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\XExecution($xml);
            $this->execution = $child;
            $happened = true;
        }
        else if (($xml->localName == 'trigger') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\XTrigger($xml);
            $this->trigger = $child;
            $happened = true;
        }
        else if (($xml->localName == 'job_conf') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\MapType($xml);
            if (!isset($this->jobConf)) {
                $this->jobConf = array();
            }
            array_push($this->jobConf, $child);
            $happened = true;
        }
        else if (($xml->localName == 'start_time') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->startTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'end_time') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->endTime = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XJob from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XJob to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->startElementNs('ns1', 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->execution) {
            $writer->startElementNs('ns1', 'execution', null);
            $this->execution->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->trigger) {
            $writer->startElementNs('ns1', 'trigger', null);
            $this->trigger->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->jobConf) {
            foreach ($this->jobConf as $i => $x) {
                $writer->startElementNs('ns1', 'job_conf', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->startTime) {
            $writer->startElementNs('ns1', 'start_time', null);
            $writer->text($this->startTime);
            $writer->endElement();
        }
        if ($this->endTime) {
            $writer->startElementNs('ns1', 'end_time', null);
            $writer->text($this->endTime);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class XSessionType
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $db;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Scheduler\MapType[]
     */
    private $conf;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Scheduler\ResourcePath[]
     */
    private $resourcePath;

    /**
     * Constructs a XSessionType from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDb()
    {
        return $this->db;
    }

    /**
     * (no documentation provided)
     *
     * @param string $db
     */
    public function setDb($db)
    {
        $this->db = $db;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Scheduler\MapType[]
     */
    public function getConf()
    {
        return $this->conf;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Scheduler\MapType[] $conf
     */
    public function setConf($conf)
    {
        $this->conf = $conf;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Scheduler\ResourcePath[]
     */
    public function getResourcePath()
    {
        return $this->resourcePath;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Scheduler\ResourcePath[] $resourcePath
     */
    public function setResourcePath($resourcePath)
    {
        $this->resourcePath = $resourcePath;
    }

    /**
     * Initializes this XSessionType from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XSessionType from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'db') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->db = $child;
            $happened = true;
        }
        else if (($xml->localName == 'conf') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\MapType($xml);
            if (!isset($this->conf)) {
                $this->conf = array();
            }
            array_push($this->conf, $child);
            $happened = true;
        }
        else if (($xml->localName == 'resource_path') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\ResourcePath($xml);
            if (!isset($this->resourcePath)) {
                $this->resourcePath = array();
            }
            array_push($this->resourcePath, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XSessionType from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XSessionType to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->db) {
            $writer->startElementNs('ns1', 'db', null);
            $writer->text($this->db);
            $writer->endElement();
        }
        if ($this->conf) {
            foreach ($this->conf as $i => $x) {
                $writer->startElementNs('ns1', 'conf', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->resourcePath) {
            foreach ($this->resourcePath as $i => $x) {
                $writer->startElementNs('ns1', 'resource_path', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class XTrigger
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Scheduler\XFrequency
     */
    private $frequency;

    /**
     * Constructs a XTrigger from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Scheduler\XFrequency
     */
    public function getFrequency()
    {
        return $this->frequency;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Scheduler\XFrequency $frequency
     */
    public function setFrequency($frequency)
    {
        $this->frequency = $frequency;
    }

    /**
     * Initializes this XTrigger from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XTrigger from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'frequency') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\XFrequency($xml);
            $this->frequency = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XTrigger from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XTrigger to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->frequency) {
            $writer->startElementNs('ns1', 'frequency', null);
            $this->frequency->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class XJobQuery
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $query;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Scheduler\MapType[]
     */
    private $conf;

    /**
     * Constructs a XJobQuery from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getQuery()
    {
        return $this->query;
    }

    /**
     * (no documentation provided)
     *
     * @param string $query
     */
    public function setQuery($query)
    {
        $this->query = $query;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Scheduler\MapType[]
     */
    public function getConf()
    {
        return $this->conf;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Scheduler\MapType[] $conf
     */
    public function setConf($conf)
    {
        $this->conf = $conf;
    }

    /**
     * Initializes this XJobQuery from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XJobQuery from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'query') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->query = $child;
            $happened = true;
        }
        else if (($xml->localName == 'conf') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\MapType($xml);
            if (!isset($this->conf)) {
                $this->conf = array();
            }
            array_push($this->conf, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XJobQuery from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XJobQuery to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->query) {
            $writer->startElementNs('ns1', 'query', null);
            $writer->text($this->query);
            $writer->endElement();
        }
        if ($this->conf) {
            foreach ($this->conf as $i => $x) {
                $writer->startElementNs('ns1', 'conf', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class XExecution
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Scheduler\XSessionType
     */
    private $session;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Scheduler\XJobQuery
     */
    private $query;

    /**
     * Constructs a XExecution from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Scheduler\XSessionType
     */
    public function getSession()
    {
        return $this->session;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Scheduler\XSessionType $session
     */
    public function setSession($session)
    {
        $this->session = $session;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Scheduler\XJobQuery
     */
    public function getQuery()
    {
        return $this->query;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Scheduler\XJobQuery $query
     */
    public function setQuery($query)
    {
        $this->query = $query;
    }

    /**
     * Initializes this XExecution from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XExecution from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'session') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\XSessionType($xml);
            $this->session = $child;
            $happened = true;
        }
        else if (($xml->localName == 'query') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = new \Org\Apache\Lens\Api\Scheduler\XJobQuery($xml);
            $this->query = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XExecution from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XExecution to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->session) {
            $writer->startElementNs('ns1', 'session', null);
            $this->session->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->query) {
            $writer->startElementNs('ns1', 'query', null);
            $this->query->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class SchedulerJobInstanceHandle
{

    /**
     * The handle id.
     *
     * @var string
     */
    private $handleId;

    /**
     * Constructs a SchedulerJobInstanceHandle from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The handle id.
     *
     * @return string
     */
    public function getHandleId()
    {
        return $this->handleId;
    }

    /**
     * The handle id.
     *
     * @param string $handleId
     */
    public function setHandleId($handleId)
    {
        $this->handleId = $handleId;
    }

    /**
     * Initializes this SchedulerJobInstanceHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of SchedulerJobInstanceHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'handleId') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->handleId = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of SchedulerJobInstanceHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this SchedulerJobInstanceHandle to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS('ns1', 'schedulerJobInstanceHandle', null);
        if ($includeNamespaces) {
            $writer->writeAttributeNs('xmlns', 'ns1', null, 'uri:lens:job:0.1');
        }
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this SchedulerJobInstanceHandle to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->handleId) {
            $writer->startElementNs('ns1', 'handleId', null);
            $writer->text($this->handleId);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class SchedulerJobHandle
{

    /**
     * The handle id.
     *
     * @var string
     */
    private $handleId;

    /**
     * Constructs a SchedulerJobHandle from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The handle id.
     *
     * @return string
     */
    public function getHandleId()
    {
        return $this->handleId;
    }

    /**
     * The handle id.
     *
     * @param string $handleId
     */
    public function setHandleId($handleId)
    {
        $this->handleId = $handleId;
    }

    /**
     * Initializes this SchedulerJobHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of SchedulerJobHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'handleId') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->handleId = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of SchedulerJobHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this SchedulerJobHandle to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS('ns1', 'schedulerJobHandle', null);
        if ($includeNamespaces) {
            $writer->writeAttributeNs('xmlns', 'ns1', null, 'uri:lens:job:0.1');
        }
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this SchedulerJobHandle to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->handleId) {
            $writer->startElementNs('ns1', 'handleId', null);
            $writer->text($this->handleId);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class MapType
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $key;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $value;

    /**
     * Constructs a MapType from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getKey()
    {
        return $this->key;
    }

    /**
     * (no documentation provided)
     *
     * @param string $key
     */
    public function setKey($key)
    {
        $this->key = $key;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getValue()
    {
        return $this->value;
    }

    /**
     * (no documentation provided)
     *
     * @param string $value
     */
    public function setValue($value)
    {
        $this->value = $value;
    }

    /**
     * Initializes this MapType from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of MapType from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'key') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->key = $child;
            $happened = true;
        }
        else if (($xml->localName == 'value') && ($xml->namespaceURI == 'uri:lens:job:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->value = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of MapType from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this MapType to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->key) {
            $writer->startElementNs('ns1', 'key', null);
            $writer->text($this->key);
            $writer->endElement();
        }
        if ($this->value) {
            $writer->startElementNs('ns1', 'value', null);
            $writer->text($this->value);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XTimePartSpec
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XTimePartSpecElement[]
     */
    private $partSpecElement;

    /**
     * Constructs a XTimePartSpec from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XTimePartSpecElement[]
     */
    public function getPartSpecElement()
    {
        return $this->partSpecElement;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XTimePartSpecElement[] $partSpecElement
     */
    public function setPartSpecElement($partSpecElement)
    {
        $this->partSpecElement = $partSpecElement;
    }

    /**
     * Initializes this XTimePartSpec from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XTimePartSpec from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'part_spec_element') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XTimePartSpecElement($xml);
            if (!isset($this->partSpecElement)) {
                $this->partSpecElement = array();
            }
            array_push($this->partSpecElement, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XTimePartSpec from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XTimePartSpec to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->partSpecElement) {
            foreach ($this->partSpecElement as $i => $x) {
                $writer->startElementNs('ns2', 'part_spec_element', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XStorageTables
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XStorageTableElement[]
     */
    private $storageTable;

    /**
     * Constructs a XStorageTables from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XStorageTableElement[]
     */
    public function getStorageTable()
    {
        return $this->storageTable;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XStorageTableElement[] $storageTable
     */
    public function setStorageTable($storageTable)
    {
        $this->storageTable = $storageTable;
    }

    /**
     * Initializes this XStorageTables from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XStorageTables from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'storage_table') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XStorageTableElement($xml);
            if (!isset($this->storageTable)) {
                $this->storageTable = array();
            }
            array_push($this->storageTable, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XStorageTables from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XStorageTables to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->storageTable) {
            foreach ($this->storageTable as $i => $x) {
                $writer->startElementNs('ns2', 'storage_table', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XStorageTableDesc
{

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $external;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $tableLocation;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $inputFormat;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $outputFormat;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $fieldDelimiter;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $escapeChar;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $collectionDelimiter;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $lineDelimiter;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $mapKeyDelimiter;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $serdeClassName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $storageHandlerName;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $numBuckets;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $compressed;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XColumns
     */
    private $partCols;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $tableParameters;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $serdeParameters;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $bucketCols;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $sortCols;

    /**
     * (no documentation provided)
     *
     * @var integer[]
     */
    private $sortColOrder;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XSkewedInfo[]
     */
    private $skewedInfo;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $timePartCols;

    /**
     * Constructs a XStorageTableDesc from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getExternal()
    {
        return $this->external;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $external
     */
    public function setExternal($external)
    {
        $this->external = $external;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getTableLocation()
    {
        return $this->tableLocation;
    }

    /**
     * (no documentation provided)
     *
     * @param string $tableLocation
     */
    public function setTableLocation($tableLocation)
    {
        $this->tableLocation = $tableLocation;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getInputFormat()
    {
        return $this->inputFormat;
    }

    /**
     * (no documentation provided)
     *
     * @param string $inputFormat
     */
    public function setInputFormat($inputFormat)
    {
        $this->inputFormat = $inputFormat;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getOutputFormat()
    {
        return $this->outputFormat;
    }

    /**
     * (no documentation provided)
     *
     * @param string $outputFormat
     */
    public function setOutputFormat($outputFormat)
    {
        $this->outputFormat = $outputFormat;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getFieldDelimiter()
    {
        return $this->fieldDelimiter;
    }

    /**
     * (no documentation provided)
     *
     * @param string $fieldDelimiter
     */
    public function setFieldDelimiter($fieldDelimiter)
    {
        $this->fieldDelimiter = $fieldDelimiter;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getEscapeChar()
    {
        return $this->escapeChar;
    }

    /**
     * (no documentation provided)
     *
     * @param string $escapeChar
     */
    public function setEscapeChar($escapeChar)
    {
        $this->escapeChar = $escapeChar;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getCollectionDelimiter()
    {
        return $this->collectionDelimiter;
    }

    /**
     * (no documentation provided)
     *
     * @param string $collectionDelimiter
     */
    public function setCollectionDelimiter($collectionDelimiter)
    {
        $this->collectionDelimiter = $collectionDelimiter;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLineDelimiter()
    {
        return $this->lineDelimiter;
    }

    /**
     * (no documentation provided)
     *
     * @param string $lineDelimiter
     */
    public function setLineDelimiter($lineDelimiter)
    {
        $this->lineDelimiter = $lineDelimiter;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getMapKeyDelimiter()
    {
        return $this->mapKeyDelimiter;
    }

    /**
     * (no documentation provided)
     *
     * @param string $mapKeyDelimiter
     */
    public function setMapKeyDelimiter($mapKeyDelimiter)
    {
        $this->mapKeyDelimiter = $mapKeyDelimiter;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSerdeClassName()
    {
        return $this->serdeClassName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $serdeClassName
     */
    public function setSerdeClassName($serdeClassName)
    {
        $this->serdeClassName = $serdeClassName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getStorageHandlerName()
    {
        return $this->storageHandlerName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $storageHandlerName
     */
    public function setStorageHandlerName($storageHandlerName)
    {
        $this->storageHandlerName = $storageHandlerName;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getNumBuckets()
    {
        return $this->numBuckets;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $numBuckets
     */
    public function setNumBuckets($numBuckets)
    {
        $this->numBuckets = $numBuckets;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getCompressed()
    {
        return $this->compressed;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $compressed
     */
    public function setCompressed($compressed)
    {
        $this->compressed = $compressed;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XColumns
     */
    public function getPartCols()
    {
        return $this->partCols;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XColumns $partCols
     */
    public function setPartCols($partCols)
    {
        $this->partCols = $partCols;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getTableParameters()
    {
        return $this->tableParameters;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $tableParameters
     */
    public function setTableParameters($tableParameters)
    {
        $this->tableParameters = $tableParameters;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getSerdeParameters()
    {
        return $this->serdeParameters;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $serdeParameters
     */
    public function setSerdeParameters($serdeParameters)
    {
        $this->serdeParameters = $serdeParameters;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getBucketCols()
    {
        return $this->bucketCols;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $bucketCols
     */
    public function setBucketCols($bucketCols)
    {
        $this->bucketCols = $bucketCols;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getSortCols()
    {
        return $this->sortCols;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $sortCols
     */
    public function setSortCols($sortCols)
    {
        $this->sortCols = $sortCols;
    }
    /**
     * (no documentation provided)
     *
     * @return integer[]
     */
    public function getSortColOrder()
    {
        return $this->sortColOrder;
    }

    /**
     * (no documentation provided)
     *
     * @param integer[] $sortColOrder
     */
    public function setSortColOrder($sortColOrder)
    {
        $this->sortColOrder = $sortColOrder;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XSkewedInfo[]
     */
    public function getSkewedInfo()
    {
        return $this->skewedInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XSkewedInfo[] $skewedInfo
     */
    public function setSkewedInfo($skewedInfo)
    {
        $this->skewedInfo = $skewedInfo;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getTimePartCols()
    {
        return $this->timePartCols;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $timePartCols
     */
    public function setTimePartCols($timePartCols)
    {
        $this->timePartCols = $timePartCols;
    }

    /**
     * Initializes this XStorageTableDesc from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XStorageTableDesc from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'part_cols') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XColumns($xml);
            $this->partCols = $child;
            $happened = true;
        }
        else if (($xml->localName == 'table_parameters') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->tableParameters = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serde_parameters') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->serdeParameters = $child;
            $happened = true;
        }
        else if (($xml->localName == 'bucket_cols') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->bucketCols)) {
                $this->bucketCols = array();
            }
            array_push($this->bucketCols, $child);
            $happened = true;
        }
        else if (($xml->localName == 'sort_cols') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->sortCols)) {
                $this->sortCols = array();
            }
            array_push($this->sortCols, $child);
            $happened = true;
        }
        else if (($xml->localName == 'sort_col_order') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->sortColOrder)) {
                $this->sortColOrder = array();
            }
            array_push($this->sortColOrder, $child);
            $happened = true;
        }
        else if (($xml->localName == 'skewed_info') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XSkewedInfo($xml);
            if (!isset($this->skewedInfo)) {
                $this->skewedInfo = array();
            }
            array_push($this->skewedInfo, $child);
            $happened = true;
        }
        else if (($xml->localName == 'time_part_cols') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->timePartCols)) {
                $this->timePartCols = array();
            }
            array_push($this->timePartCols, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XStorageTableDesc from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'external') && (empty($xml->namespaceURI))) {
            $this->external = $xml->value;
            return true;
        }
        if (($xml->localName == 'table_location') && (empty($xml->namespaceURI))) {
            $this->tableLocation = $xml->value;
            return true;
        }
        if (($xml->localName == 'input_format') && (empty($xml->namespaceURI))) {
            $this->inputFormat = $xml->value;
            return true;
        }
        if (($xml->localName == 'output_format') && (empty($xml->namespaceURI))) {
            $this->outputFormat = $xml->value;
            return true;
        }
        if (($xml->localName == 'field_delimiter') && (empty($xml->namespaceURI))) {
            $this->fieldDelimiter = $xml->value;
            return true;
        }
        if (($xml->localName == 'escape_char') && (empty($xml->namespaceURI))) {
            $this->escapeChar = $xml->value;
            return true;
        }
        if (($xml->localName == 'collection_delimiter') && (empty($xml->namespaceURI))) {
            $this->collectionDelimiter = $xml->value;
            return true;
        }
        if (($xml->localName == 'line_delimiter') && (empty($xml->namespaceURI))) {
            $this->lineDelimiter = $xml->value;
            return true;
        }
        if (($xml->localName == 'map_key_delimiter') && (empty($xml->namespaceURI))) {
            $this->mapKeyDelimiter = $xml->value;
            return true;
        }
        if (($xml->localName == 'serde_class_name') && (empty($xml->namespaceURI))) {
            $this->serdeClassName = $xml->value;
            return true;
        }
        if (($xml->localName == 'storage_handler_name') && (empty($xml->namespaceURI))) {
            $this->storageHandlerName = $xml->value;
            return true;
        }
        if (($xml->localName == 'num_buckets') && (empty($xml->namespaceURI))) {
            $this->numBuckets = $xml->value;
            return true;
        }
        if (($xml->localName == 'compressed') && (empty($xml->namespaceURI))) {
            $this->compressed = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XStorageTableDesc to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->external) {
            $writer->writeAttribute('external', $this->external);
        }
        if ($this->tableLocation) {
            $writer->writeAttribute('table_location', $this->tableLocation);
        }
        if ($this->inputFormat) {
            $writer->writeAttribute('input_format', $this->inputFormat);
        }
        if ($this->outputFormat) {
            $writer->writeAttribute('output_format', $this->outputFormat);
        }
        if ($this->fieldDelimiter) {
            $writer->writeAttribute('field_delimiter', $this->fieldDelimiter);
        }
        if ($this->escapeChar) {
            $writer->writeAttribute('escape_char', $this->escapeChar);
        }
        if ($this->collectionDelimiter) {
            $writer->writeAttribute('collection_delimiter', $this->collectionDelimiter);
        }
        if ($this->lineDelimiter) {
            $writer->writeAttribute('line_delimiter', $this->lineDelimiter);
        }
        if ($this->mapKeyDelimiter) {
            $writer->writeAttribute('map_key_delimiter', $this->mapKeyDelimiter);
        }
        if ($this->serdeClassName) {
            $writer->writeAttribute('serde_class_name', $this->serdeClassName);
        }
        if ($this->storageHandlerName) {
            $writer->writeAttribute('storage_handler_name', $this->storageHandlerName);
        }
        if ($this->numBuckets) {
            $writer->writeAttribute('num_buckets', $this->numBuckets);
        }
        if ($this->compressed) {
            $writer->writeAttribute('compressed', $this->compressed);
        }
        if ($this->partCols) {
            $writer->startElementNs('ns2', 'part_cols', null);
            $this->partCols->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->tableParameters) {
            $writer->startElementNs('ns2', 'table_parameters', null);
            $this->tableParameters->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->serdeParameters) {
            $writer->startElementNs('ns2', 'serde_parameters', null);
            $this->serdeParameters->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->bucketCols) {
            foreach ($this->bucketCols as $i => $x) {
                $writer->startElementNs('ns2', 'bucket_cols', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->sortCols) {
            foreach ($this->sortCols as $i => $x) {
                $writer->startElementNs('ns2', 'sort_cols', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->sortColOrder) {
            foreach ($this->sortColOrder as $i => $x) {
                $writer->startElementNs('ns2', 'sort_col_order', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->skewedInfo) {
            foreach ($this->skewedInfo as $i => $x) {
                $writer->startElementNs('ns2', 'skewed_info', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->timePartCols) {
            foreach ($this->timePartCols as $i => $x) {
                $writer->startElementNs('ns2', 'time_part_cols', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XSkewedValueLocation
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $location;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XSkewColList
     */
    private $value;

    /**
     * Constructs a XSkewedValueLocation from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * (no documentation provided)
     *
     * @param string $location
     */
    public function setLocation($location)
    {
        $this->location = $location;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XSkewColList
     */
    public function getValue()
    {
        return $this->value;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XSkewColList $value
     */
    public function setValue($value)
    {
        $this->value = $value;
    }

    /**
     * Initializes this XSkewedValueLocation from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XSkewedValueLocation from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'value') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XSkewColList($xml);
            $this->value = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XSkewedValueLocation from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'location') && (empty($xml->namespaceURI))) {
            $this->location = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XSkewedValueLocation to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->location) {
            $writer->writeAttribute('location', $this->location);
        }
        if ($this->value) {
            $writer->startElementNs('ns2', 'value', null);
            $this->value->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XSkewColList
{

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $elements;

    /**
     * Constructs a XSkewColList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getElements()
    {
        return $this->elements;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $elements
     */
    public function setElements($elements)
    {
        $this->elements = $elements;
    }

    /**
     * Initializes this XSkewColList from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XSkewColList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'elements') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->elements)) {
                $this->elements = array();
            }
            array_push($this->elements, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XSkewColList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XSkewColList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->elements) {
            foreach ($this->elements as $i => $x) {
                $writer->startElementNs('ns2', 'elements', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XSegmentation
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $cubeName;

    /**
     * (no documentation provided)
     *
     * @var double
     */
    private $weight;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $properties;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XSegments
     */
    private $segements;

    /**
     * Constructs a XSegmentation from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getCubeName()
    {
        return $this->cubeName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $cubeName
     */
    public function setCubeName($cubeName)
    {
        $this->cubeName = $cubeName;
    }
    /**
     * (no documentation provided)
     *
     * @return double
     */
    public function getWeight()
    {
        return $this->weight;
    }

    /**
     * (no documentation provided)
     *
     * @param double $weight
     */
    public function setWeight($weight)
    {
        $this->weight = $weight;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getProperties()
    {
        return $this->properties;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $properties
     */
    public function setProperties($properties)
    {
        $this->properties = $properties;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XSegments
     */
    public function getSegements()
    {
        return $this->segements;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XSegments $segements
     */
    public function setSegements($segements)
    {
        $this->segements = $segements;
    }

    /**
     * Initializes this XSegmentation from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XSegmentation from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'properties') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->properties = $child;
            $happened = true;
        }
        else if (($xml->localName == 'segements') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XSegments($xml);
            $this->segements = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XSegmentation from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $this->name = $xml->value;
            return true;
        }
        if (($xml->localName == 'cube_name') && (empty($xml->namespaceURI))) {
            $this->cubeName = $xml->value;
            return true;
        }
        if (($xml->localName == 'weight') && (empty($xml->namespaceURI))) {
            $this->weight = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XSegmentation to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->writeAttribute('name', $this->name);
        }
        if ($this->cubeName) {
            $writer->writeAttribute('cube_name', $this->cubeName);
        }
        if ($this->weight) {
            $writer->writeAttribute('weight', $this->weight);
        }
        if ($this->properties) {
            $writer->startElementNs('ns2', 'properties', null);
            $this->properties->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->segements) {
            $writer->startElementNs('ns2', 'segements', null);
            $this->segements->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XProperty
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $value;

    /**
     * Constructs a XProperty from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getValue()
    {
        return $this->value;
    }

    /**
     * (no documentation provided)
     *
     * @param string $value
     */
    public function setValue($value)
    {
        $this->value = $value;
    }

    /**
     * Initializes this XProperty from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XProperty from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of XProperty from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $this->name = $xml->value;
            return true;
        }
        if (($xml->localName == 'value') && (empty($xml->namespaceURI))) {
            $this->value = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XProperty to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->writeAttribute('name', $this->name);
        }
        if ($this->value) {
            $writer->writeAttribute('value', $this->value);
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XPartitionList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XPartition[]
     */
    private $partition;

    /**
     * Constructs a XPartitionList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XPartition[]
     */
    public function getPartition()
    {
        return $this->partition;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XPartition[] $partition
     */
    public function setPartition($partition)
    {
        $this->partition = $partition;
    }

    /**
     * Initializes this XPartitionList from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XPartitionList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'partition') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XPartition($xml);
            if (!isset($this->partition)) {
                $this->partition = array();
            }
            array_push($this->partition, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XPartitionList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XPartitionList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->partition) {
            foreach ($this->partition as $i => $x) {
                $writer->startElementNs('ns2', 'partition', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XPartSpecElement
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $key;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $value;

    /**
     * Constructs a XPartSpecElement from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getKey()
    {
        return $this->key;
    }

    /**
     * (no documentation provided)
     *
     * @param string $key
     */
    public function setKey($key)
    {
        $this->key = $key;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getValue()
    {
        return $this->value;
    }

    /**
     * (no documentation provided)
     *
     * @param string $value
     */
    public function setValue($value)
    {
        $this->value = $value;
    }

    /**
     * Initializes this XPartSpecElement from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XPartSpecElement from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of XPartSpecElement from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'key') && (empty($xml->namespaceURI))) {
            $this->key = $xml->value;
            return true;
        }
        if (($xml->localName == 'value') && (empty($xml->namespaceURI))) {
            $this->value = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XPartSpecElement to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->key) {
            $writer->writeAttribute('key', $this->key);
        }
        if ($this->value) {
            $writer->writeAttribute('value', $this->value);
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XNativeTable
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $dbname;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $owner;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $tableType;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $createtime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $lastAccessTime;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XColumns
     */
    private $columns;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XStorageTableDesc
     */
    private $storageDescriptor;

    /**
     * Constructs a XNativeTable from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDbname()
    {
        return $this->dbname;
    }

    /**
     * (no documentation provided)
     *
     * @param string $dbname
     */
    public function setDbname($dbname)
    {
        $this->dbname = $dbname;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * (no documentation provided)
     *
     * @param string $owner
     */
    public function setOwner($owner)
    {
        $this->owner = $owner;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getTableType()
    {
        return $this->tableType;
    }

    /**
     * (no documentation provided)
     *
     * @param string $tableType
     */
    public function setTableType($tableType)
    {
        $this->tableType = $tableType;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getCreatetime()
    {
        return $this->createtime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $createtime
     */
    public function setCreatetime($createtime)
    {
        $this->createtime = $createtime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getLastAccessTime()
    {
        return $this->lastAccessTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $lastAccessTime
     */
    public function setLastAccessTime($lastAccessTime)
    {
        $this->lastAccessTime = $lastAccessTime;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XColumns
     */
    public function getColumns()
    {
        return $this->columns;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XColumns $columns
     */
    public function setColumns($columns)
    {
        $this->columns = $columns;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XStorageTableDesc
     */
    public function getStorageDescriptor()
    {
        return $this->storageDescriptor;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XStorageTableDesc $storageDescriptor
     */
    public function setStorageDescriptor($storageDescriptor)
    {
        $this->storageDescriptor = $storageDescriptor;
    }

    /**
     * Initializes this XNativeTable from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XNativeTable from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'columns') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XColumns($xml);
            $this->columns = $child;
            $happened = true;
        }
        else if (($xml->localName == 'storage_descriptor') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XStorageTableDesc($xml);
            $this->storageDescriptor = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XNativeTable from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $this->name = $xml->value;
            return true;
        }
        if (($xml->localName == 'dbname') && (empty($xml->namespaceURI))) {
            $this->dbname = $xml->value;
            return true;
        }
        if (($xml->localName == 'owner') && (empty($xml->namespaceURI))) {
            $this->owner = $xml->value;
            return true;
        }
        if (($xml->localName == 'table_type') && (empty($xml->namespaceURI))) {
            $this->tableType = $xml->value;
            return true;
        }
        if (($xml->localName == 'createtime') && (empty($xml->namespaceURI))) {
            $this->createtime = $xml->value;
            return true;
        }
        if (($xml->localName == 'lastAccessTime') && (empty($xml->namespaceURI))) {
            $this->lastAccessTime = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XNativeTable to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->writeAttribute('name', $this->name);
        }
        if ($this->dbname) {
            $writer->writeAttribute('dbname', $this->dbname);
        }
        if ($this->owner) {
            $writer->writeAttribute('owner', $this->owner);
        }
        if ($this->tableType) {
            $writer->writeAttribute('table_type', $this->tableType);
        }
        if ($this->createtime) {
            $writer->writeAttribute('createtime', $this->createtime);
        }
        if ($this->lastAccessTime) {
            $writer->writeAttribute('lastAccessTime', $this->lastAccessTime);
        }
        if ($this->columns) {
            $writer->startElementNs('ns2', 'columns', null);
            $this->columns->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->storageDescriptor) {
            $writer->startElementNs('ns2', 'storage_descriptor', null);
            $this->storageDescriptor->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XJoinPath
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XJoinEdges
     */
    private $edges;

    /**
     * Constructs a XJoinPath from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XJoinEdges
     */
    public function getEdges()
    {
        return $this->edges;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XJoinEdges $edges
     */
    public function setEdges($edges)
    {
        $this->edges = $edges;
    }

    /**
     * Initializes this XJoinPath from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XJoinPath from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'edges') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XJoinEdges($xml);
            $this->edges = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XJoinPath from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XJoinPath to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->edges) {
            $writer->startElementNs('ns2', 'edges', null);
            $this->edges->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XJoinEdge
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XTableReference
     */
    private $from;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XTableReference
     */
    private $to;

    /**
     * Constructs a XJoinEdge from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XTableReference
     */
    public function getFrom()
    {
        return $this->from;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XTableReference $from
     */
    public function setFrom($from)
    {
        $this->from = $from;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XTableReference
     */
    public function getTo()
    {
        return $this->to;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XTableReference $to
     */
    public function setTo($to)
    {
        $this->to = $to;
    }

    /**
     * Initializes this XJoinEdge from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of XJoinEdge from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'from') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XTableReference($xml);
            $this->from = $child;
            $happened = true;
        }
        else if (($xml->localName == 'to') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XTableReference($xml);
            $this->to = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XJoinEdge from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this XJoinEdge to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->from) {
            $writer->startElementNs('ns2', 'from', null);
            $this->from->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->to) {
            $writer->startElementNs('ns2', 'to', null);
            $this->to->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api;

/**
 * (no documentation provided)
 */
class StringList
{

    /**
     * The elements.
     *
     * @var string[]
     */
    private $elements;

    /**
     * Constructs a StringList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The elements.
     *
     * @return string[]
     */
    public function getElements()
    {
        return $this->elements;
    }

    /**
     * The elements.
     *
     * @param string[] $elements
     */
    public function setElements($elements)
    {
        $this->elements = $elements;
    }

    /**
     * Initializes this StringList from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of StringList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'elements') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->elements)) {
                $this->elements = array();
            }
            array_push($this->elements, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of StringList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this StringList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'stringList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this StringList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->elements) {
            foreach ($this->elements as $i => $x) {
                $writer->startElementNs(null, 'elements', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XFactTable extends \Org\Apache\Lens\Api\Metastore\XFact
{

    /**
     * (no documentation provided)
     *
     * @var double
     */
    private $weight;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XColumns
     */
    private $columns;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $properties;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XStorageTables
     */
    private $storageTables;

    /**
     * Constructs a XFactTable from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return double
     */
    public function getWeight()
    {
        return $this->weight;
    }

    /**
     * (no documentation provided)
     *
     * @param double $weight
     */
    public function setWeight($weight)
    {
        $this->weight = $weight;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XColumns
     */
    public function getColumns()
    {
        return $this->columns;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XColumns $columns
     */
    public function setColumns($columns)
    {
        $this->columns = $columns;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getProperties()
    {
        return $this->properties;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $properties
     */
    public function setProperties($properties)
    {
        $this->properties = $properties;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XStorageTables
     */
    public function getStorageTables()
    {
        return $this->storageTables;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XStorageTables $storageTables
     */
    public function setStorageTables($storageTables)
    {
        $this->storageTables = $storageTables;
    }

    /**
     * Sets a known child element of XFactTable from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'columns') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XColumns($xml);
            $this->columns = $child;
            $happened = true;
        }
        else if (($xml->localName == 'properties') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->properties = $child;
            $happened = true;
        }
        else if (($xml->localName == 'storage_tables') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XStorageTables($xml);
            $this->storageTables = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XFactTable from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }
        else if (($xml->localName == 'weight') && (empty($xml->namespaceURI))) {
            $this->weight = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XFactTable to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->weight) {
            $writer->writeAttribute('weight', $this->weight);
        }
        parent::writeXmlContents($writer);
        if ($this->columns) {
            $writer->startElementNs('ns2', 'columns', null);
            $this->columns->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->properties) {
            $writer->startElementNs('ns2', 'properties', null);
            $this->properties->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->storageTables) {
            $writer->startElementNs('ns2', 'storage_tables', null);
            $this->storageTables->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class LensPreparedQuery extends \Org\Apache\Lens\Api\ToYAMLString
{

    /**
     * The prepare handle.
     *
     * @var \Org\Apache\Lens\Api\Query\QueryPrepareHandle
     */
    private $prepareHandle;

    /**
     * The user query.
     *
     * @var string
     */
    private $userQuery;

    /**
     * The prepared time.
     *
     * @var integer
     */
    private $preparedTime;

    /**
     * The prepared user.
     *
     * @var string
     */
    private $preparedUser;

    /**
     * The selected driver&#39;s fully qualified name.
     *
     * @var string
     */
    private $selectedDriverName;

    /**
     * The driver query.
     *
     * @var string
     */
    private $driverQuery;

    /**
     * The conf.
     *
     * @var \Org\Apache\Lens\Api\LensConf
     */
    private $conf;

    /**
     * Constructs a LensPreparedQuery from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The prepare handle.
     *
     * @return \Org\Apache\Lens\Api\Query\QueryPrepareHandle
     */
    public function getPrepareHandle()
    {
        return $this->prepareHandle;
    }

    /**
     * The prepare handle.
     *
     * @param \Org\Apache\Lens\Api\Query\QueryPrepareHandle $prepareHandle
     */
    public function setPrepareHandle($prepareHandle)
    {
        $this->prepareHandle = $prepareHandle;
    }
    /**
     * The user query.
     *
     * @return string
     */
    public function getUserQuery()
    {
        return $this->userQuery;
    }

    /**
     * The user query.
     *
     * @param string $userQuery
     */
    public function setUserQuery($userQuery)
    {
        $this->userQuery = $userQuery;
    }
    /**
     * The prepared time.
     *
     * @return integer
     */
    public function getPreparedTime()
    {
        return $this->preparedTime;
    }

    /**
     * The prepared time.
     *
     * @param integer $preparedTime
     */
    public function setPreparedTime($preparedTime)
    {
        $this->preparedTime = $preparedTime;
    }
    /**
     * The prepared user.
     *
     * @return string
     */
    public function getPreparedUser()
    {
        return $this->preparedUser;
    }

    /**
     * The prepared user.
     *
     * @param string $preparedUser
     */
    public function setPreparedUser($preparedUser)
    {
        $this->preparedUser = $preparedUser;
    }
    /**
     * The selected driver&#39;s fully qualified name.
     *
     * @return string
     */
    public function getSelectedDriverName()
    {
        return $this->selectedDriverName;
    }

    /**
     * The selected driver&#39;s fully qualified name.
     *
     * @param string $selectedDriverName
     */
    public function setSelectedDriverName($selectedDriverName)
    {
        $this->selectedDriverName = $selectedDriverName;
    }
    /**
     * The driver query.
     *
     * @return string
     */
    public function getDriverQuery()
    {
        return $this->driverQuery;
    }

    /**
     * The driver query.
     *
     * @param string $driverQuery
     */
    public function setDriverQuery($driverQuery)
    {
        $this->driverQuery = $driverQuery;
    }
    /**
     * The conf.
     *
     * @return \Org\Apache\Lens\Api\LensConf
     */
    public function getConf()
    {
        return $this->conf;
    }

    /**
     * The conf.
     *
     * @param \Org\Apache\Lens\Api\LensConf $conf
     */
    public function setConf($conf)
    {
        $this->conf = $conf;
    }

    /**
     * Sets a known child element of LensPreparedQuery from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'prepareHandle') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\QueryPrepareHandle($xml);
            $this->prepareHandle = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userQuery') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userQuery = $child;
            $happened = true;
        }
        else if (($xml->localName == 'preparedTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->preparedTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'preparedUser') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->preparedUser = $child;
            $happened = true;
        }
        else if (($xml->localName == 'selectedDriverName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->selectedDriverName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'driverQuery') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->driverQuery = $child;
            $happened = true;
        }
        else if (($xml->localName == 'conf') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\LensConf($xml);
            $this->conf = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of LensPreparedQuery from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this LensPreparedQuery to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'lensPreparedQuery', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this LensPreparedQuery to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->prepareHandle) {
            $writer->startElementNs(null, 'prepareHandle', null);
            $this->prepareHandle->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->userQuery) {
            $writer->startElementNs(null, 'userQuery', null);
            $writer->text($this->userQuery);
            $writer->endElement();
        }
        if ($this->preparedTime) {
            $writer->startElementNs(null, 'preparedTime', null);
            $writer->text($this->preparedTime);
            $writer->endElement();
        }
        if ($this->preparedUser) {
            $writer->startElementNs(null, 'preparedUser', null);
            $writer->text($this->preparedUser);
            $writer->endElement();
        }
        if ($this->selectedDriverName) {
            $writer->startElementNs(null, 'selectedDriverName', null);
            $writer->text($this->selectedDriverName);
            $writer->endElement();
        }
        if ($this->driverQuery) {
            $writer->startElementNs(null, 'driverQuery', null);
            $writer->text($this->driverQuery);
            $writer->endElement();
        }
        if ($this->conf) {
            $writer->startElementNs(null, 'conf', null);
            $this->conf->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XExprColumn extends \Org\Apache\Lens\Api\Metastore\XField
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XExprSpec[]
     */
    private $exprSpec;

    /**
     * Constructs a XExprColumn from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XExprSpec[]
     */
    public function getExprSpec()
    {
        return $this->exprSpec;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XExprSpec[] $exprSpec
     */
    public function setExprSpec($exprSpec)
    {
        $this->exprSpec = $exprSpec;
    }

    /**
     * Sets a known child element of XExprColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'expr_spec') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XExprSpec($xml);
            if (!isset($this->exprSpec)) {
                $this->exprSpec = array();
            }
            array_push($this->exprSpec, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XExprColumn from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }
        else if (($xml->localName == '_type') && (empty($xml->namespaceURI))) {
            $this->type = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XExprColumn to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->type) {
            $writer->writeAttribute('_type', $this->type);
        }
        parent::writeXmlContents($writer);
        if ($this->exprSpec) {
            foreach ($this->exprSpec as $i => $x) {
                $writer->startElementNs('ns2', 'expr_spec', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class LensQuery extends \Org\Apache\Lens\Api\ToYAMLString
{

    /**
     * The query handle that represents this query uniquely
     *
     * @var \Org\Apache\Lens\Api\Query\QueryHandle
     */
    private $queryHandle;

    /**
     * The the query submitted by the user
     *
     * @var string
     */
    private $userQuery;

    /**
     * The user who submitted the query.
     *
     * @var string
     */
    private $submittedUser;

    /**
     * The priority of the query.
     *
     * @var string
     */
    private $priority;

    /**
     * Is true if query&#39;s result would be persisted by server.
     *
     * @var boolean
     */
    private $isPersistent;

    /**
     * Name of the driver which executed the query (Example: hive/testDriver, jdbc/prodDriver etc)
     *
     * @var string
     */
    private $selectedDriverName;

    /**
     * The driver query.
     * It is the final query (derived form user query) that was submitted by the driver for execution.
     *
     * @var string
     */
    private $driverQuery;

    /**
     * The status of this query.
     * Note: QueryStatus#getStatus() method can be used to get the QueryStatus.Status enum that defines
     * the current state of the query. Also other utility methods are available to check the status of the query like
     * QueryStatus#queued(), QueryStatus#successful(), QueryStatus#finished(),
     * QueryStatus#failed() and QueryStatus#running()
     *
     * @var \Org\Apache\Lens\Api\Query\QueryStatus
     */
    private $status;

    /**
     * The result set path for this query if the query output was persisted by the server.
     *
     * @var string
     */
    private $resultSetPath;

    /**
     * The operation handle associated with the driver, if any.
     *
     * @var string
     */
    private $driverOpHandle;

    /**
     * The query conf that was used for executing this query.
     *
     * @var \Org\Apache\Lens\Api\LensConf
     */
    private $queryConf;

    /**
     * The submission time.
     *
     * @var integer
     */
    private $submissionTime;

    /**
     * The query launch time. This will be submission time + time spent by query waiting in the queue
     *
     * @var integer
     */
    private $launchTime;

    /**
     * The query execution start time on driver. This will &gt;= launch time.
     *
     * @var integer
     */
    private $driverStartTime;

    /**
     * The the query execution end time on driver.
     *
     * @var integer
     */
    private $driverFinishTime;

    /**
     * The query finish time on server. This will be driver finish time + any extra time spent by server (like
     * formatting the result)
     *
     * @var integer
     */
    private $finishTime;

    /**
     * The the query close time when the query is purged by the server and no more operations are pending for it.
     * Note: not supported as of now.
     *
     * @var integer
     */
    private $closedTime;

    /**
     * The query name, if any.
     *
     * @var string
     */
    private $queryName;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Query\FailedAttempt[]
     */
    private $failedAttempts;

    /**
     * Constructs a LensQuery from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The query handle that represents this query uniquely
     *
     * @return \Org\Apache\Lens\Api\Query\QueryHandle
     */
    public function getQueryHandle()
    {
        return $this->queryHandle;
    }

    /**
     * The query handle that represents this query uniquely
     *
     * @param \Org\Apache\Lens\Api\Query\QueryHandle $queryHandle
     */
    public function setQueryHandle($queryHandle)
    {
        $this->queryHandle = $queryHandle;
    }
    /**
     * The the query submitted by the user
     *
     * @return string
     */
    public function getUserQuery()
    {
        return $this->userQuery;
    }

    /**
     * The the query submitted by the user
     *
     * @param string $userQuery
     */
    public function setUserQuery($userQuery)
    {
        $this->userQuery = $userQuery;
    }
    /**
     * The user who submitted the query.
     *
     * @return string
     */
    public function getSubmittedUser()
    {
        return $this->submittedUser;
    }

    /**
     * The user who submitted the query.
     *
     * @param string $submittedUser
     */
    public function setSubmittedUser($submittedUser)
    {
        $this->submittedUser = $submittedUser;
    }
    /**
     * The priority of the query.
     *
     * @return string
     */
    public function getPriority()
    {
        return $this->priority;
    }

    /**
     * The priority of the query.
     *
     * @param string $priority
     */
    public function setPriority($priority)
    {
        $this->priority = $priority;
    }
    /**
     * Is true if query&#39;s result would be persisted by server.
     *
     * @return boolean
     */
    public function getIsPersistent()
    {
        return $this->isPersistent;
    }

    /**
     * Is true if query&#39;s result would be persisted by server.
     *
     * @param boolean $isPersistent
     */
    public function setIsPersistent($isPersistent)
    {
        $this->isPersistent = $isPersistent;
    }
    /**
     * Name of the driver which executed the query (Example: hive/testDriver, jdbc/prodDriver etc)
     *
     * @return string
     */
    public function getSelectedDriverName()
    {
        return $this->selectedDriverName;
    }

    /**
     * Name of the driver which executed the query (Example: hive/testDriver, jdbc/prodDriver etc)
     *
     * @param string $selectedDriverName
     */
    public function setSelectedDriverName($selectedDriverName)
    {
        $this->selectedDriverName = $selectedDriverName;
    }
    /**
     * The driver query.
       * It is the final query (derived form user query) that was submitted by the driver for execution.
     *
     * @return string
     */
    public function getDriverQuery()
    {
        return $this->driverQuery;
    }

    /**
     * The driver query.
       * It is the final query (derived form user query) that was submitted by the driver for execution.
     *
     * @param string $driverQuery
     */
    public function setDriverQuery($driverQuery)
    {
        $this->driverQuery = $driverQuery;
    }
    /**
     * The status of this query.
       * Note: QueryStatus#getStatus() method can be used to get the QueryStatus.Status enum that defines
       * the current state of the query. Also other utility methods are available to check the status of the query like
       * QueryStatus#queued(), QueryStatus#successful(), QueryStatus#finished(),
       * QueryStatus#failed() and QueryStatus#running()
     *
     * @return \Org\Apache\Lens\Api\Query\QueryStatus
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * The status of this query.
       * Note: QueryStatus#getStatus() method can be used to get the QueryStatus.Status enum that defines
       * the current state of the query. Also other utility methods are available to check the status of the query like
       * QueryStatus#queued(), QueryStatus#successful(), QueryStatus#finished(),
       * QueryStatus#failed() and QueryStatus#running()
     *
     * @param \Org\Apache\Lens\Api\Query\QueryStatus $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }
    /**
     * The result set path for this query if the query output was persisted by the server.
     *
     * @return string
     */
    public function getResultSetPath()
    {
        return $this->resultSetPath;
    }

    /**
     * The result set path for this query if the query output was persisted by the server.
     *
     * @param string $resultSetPath
     */
    public function setResultSetPath($resultSetPath)
    {
        $this->resultSetPath = $resultSetPath;
    }
    /**
     * The operation handle associated with the driver, if any.
     *
     * @return string
     */
    public function getDriverOpHandle()
    {
        return $this->driverOpHandle;
    }

    /**
     * The operation handle associated with the driver, if any.
     *
     * @param string $driverOpHandle
     */
    public function setDriverOpHandle($driverOpHandle)
    {
        $this->driverOpHandle = $driverOpHandle;
    }
    /**
     * The query conf that was used for executing this query.
     *
     * @return \Org\Apache\Lens\Api\LensConf
     */
    public function getQueryConf()
    {
        return $this->queryConf;
    }

    /**
     * The query conf that was used for executing this query.
     *
     * @param \Org\Apache\Lens\Api\LensConf $queryConf
     */
    public function setQueryConf($queryConf)
    {
        $this->queryConf = $queryConf;
    }
    /**
     * The submission time.
     *
     * @return integer
     */
    public function getSubmissionTime()
    {
        return $this->submissionTime;
    }

    /**
     * The submission time.
     *
     * @param integer $submissionTime
     */
    public function setSubmissionTime($submissionTime)
    {
        $this->submissionTime = $submissionTime;
    }
    /**
     * The query launch time. This will be submission time + time spent by query waiting in the queue
     *
     * @return integer
     */
    public function getLaunchTime()
    {
        return $this->launchTime;
    }

    /**
     * The query launch time. This will be submission time + time spent by query waiting in the queue
     *
     * @param integer $launchTime
     */
    public function setLaunchTime($launchTime)
    {
        $this->launchTime = $launchTime;
    }
    /**
     * The query execution start time on driver. This will &gt;= launch time.
     *
     * @return integer
     */
    public function getDriverStartTime()
    {
        return $this->driverStartTime;
    }

    /**
     * The query execution start time on driver. This will &gt;= launch time.
     *
     * @param integer $driverStartTime
     */
    public function setDriverStartTime($driverStartTime)
    {
        $this->driverStartTime = $driverStartTime;
    }
    /**
     * The the query execution end time on driver.
     *
     * @return integer
     */
    public function getDriverFinishTime()
    {
        return $this->driverFinishTime;
    }

    /**
     * The the query execution end time on driver.
     *
     * @param integer $driverFinishTime
     */
    public function setDriverFinishTime($driverFinishTime)
    {
        $this->driverFinishTime = $driverFinishTime;
    }
    /**
     * The query finish time on server. This will be driver finish time + any extra time spent by server (like
       * formatting the result)
     *
     * @return integer
     */
    public function getFinishTime()
    {
        return $this->finishTime;
    }

    /**
     * The query finish time on server. This will be driver finish time + any extra time spent by server (like
       * formatting the result)
     *
     * @param integer $finishTime
     */
    public function setFinishTime($finishTime)
    {
        $this->finishTime = $finishTime;
    }
    /**
     * The the query close time when the query is purged by the server and no more operations are pending for it.
       * Note: not supported as of now.
     *
     * @return integer
     */
    public function getClosedTime()
    {
        return $this->closedTime;
    }

    /**
     * The the query close time when the query is purged by the server and no more operations are pending for it.
       * Note: not supported as of now.
     *
     * @param integer $closedTime
     */
    public function setClosedTime($closedTime)
    {
        $this->closedTime = $closedTime;
    }
    /**
     * The query name, if any.
     *
     * @return string
     */
    public function getQueryName()
    {
        return $this->queryName;
    }

    /**
     * The query name, if any.
     *
     * @param string $queryName
     */
    public function setQueryName($queryName)
    {
        $this->queryName = $queryName;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Query\FailedAttempt[]
     */
    public function getFailedAttempts()
    {
        return $this->failedAttempts;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Query\FailedAttempt[] $failedAttempts
     */
    public function setFailedAttempts($failedAttempts)
    {
        $this->failedAttempts = $failedAttempts;
    }

    /**
     * Sets a known child element of LensQuery from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'queryHandle') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\QueryHandle($xml);
            $this->queryHandle = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userQuery') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userQuery = $child;
            $happened = true;
        }
        else if (($xml->localName == 'submittedUser') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->submittedUser = $child;
            $happened = true;
        }
        else if (($xml->localName == 'priority') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->priority = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isPersistent') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isPersistent = $child;
            $happened = true;
        }
        else if (($xml->localName == 'selectedDriverName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->selectedDriverName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'driverQuery') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->driverQuery = $child;
            $happened = true;
        }
        else if (($xml->localName == 'status') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\QueryStatus($xml);
            $this->status = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resultSetPath') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resultSetPath = $child;
            $happened = true;
        }
        else if (($xml->localName == 'driverOpHandle') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->driverOpHandle = $child;
            $happened = true;
        }
        else if (($xml->localName == 'queryConf') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\LensConf($xml);
            $this->queryConf = $child;
            $happened = true;
        }
        else if (($xml->localName == 'submissionTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->submissionTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'launchTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->launchTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'driverStartTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->driverStartTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'driverFinishTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->driverFinishTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'finishTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->finishTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'closedTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->closedTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'queryName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->queryName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'failedAttempts') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\FailedAttempt($xml);
            if (!isset($this->failedAttempts)) {
                $this->failedAttempts = array();
            }
            array_push($this->failedAttempts, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of LensQuery from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this LensQuery to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'lensQuery', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this LensQuery to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->queryHandle) {
            $writer->startElementNs(null, 'queryHandle', null);
            $this->queryHandle->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->userQuery) {
            $writer->startElementNs(null, 'userQuery', null);
            $writer->text($this->userQuery);
            $writer->endElement();
        }
        if ($this->submittedUser) {
            $writer->startElementNs(null, 'submittedUser', null);
            $writer->text($this->submittedUser);
            $writer->endElement();
        }
        if ($this->priority) {
            $writer->startElementNs(null, 'priority', null);
            $writer->text($this->priority);
            $writer->endElement();
        }
        if ($this->isPersistent) {
            $writer->startElementNs(null, 'isPersistent', null);
            $writer->text($this->isPersistent);
            $writer->endElement();
        }
        if ($this->selectedDriverName) {
            $writer->startElementNs(null, 'selectedDriverName', null);
            $writer->text($this->selectedDriverName);
            $writer->endElement();
        }
        if ($this->driverQuery) {
            $writer->startElementNs(null, 'driverQuery', null);
            $writer->text($this->driverQuery);
            $writer->endElement();
        }
        if ($this->status) {
            $writer->startElementNs(null, 'status', null);
            $this->status->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->resultSetPath) {
            $writer->startElementNs(null, 'resultSetPath', null);
            $writer->text($this->resultSetPath);
            $writer->endElement();
        }
        if ($this->driverOpHandle) {
            $writer->startElementNs(null, 'driverOpHandle', null);
            $writer->text($this->driverOpHandle);
            $writer->endElement();
        }
        if ($this->queryConf) {
            $writer->startElementNs(null, 'queryConf', null);
            $this->queryConf->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->submissionTime) {
            $writer->startElementNs(null, 'submissionTime', null);
            $writer->text($this->submissionTime);
            $writer->endElement();
        }
        if ($this->launchTime) {
            $writer->startElementNs(null, 'launchTime', null);
            $writer->text($this->launchTime);
            $writer->endElement();
        }
        if ($this->driverStartTime) {
            $writer->startElementNs(null, 'driverStartTime', null);
            $writer->text($this->driverStartTime);
            $writer->endElement();
        }
        if ($this->driverFinishTime) {
            $writer->startElementNs(null, 'driverFinishTime', null);
            $writer->text($this->driverFinishTime);
            $writer->endElement();
        }
        if ($this->finishTime) {
            $writer->startElementNs(null, 'finishTime', null);
            $writer->text($this->finishTime);
            $writer->endElement();
        }
        if ($this->closedTime) {
            $writer->startElementNs(null, 'closedTime', null);
            $writer->text($this->closedTime);
            $writer->endElement();
        }
        if ($this->queryName) {
            $writer->startElementNs(null, 'queryName', null);
            $writer->text($this->queryName);
            $writer->endElement();
        }
        if ($this->failedAttempts) {
            foreach ($this->failedAttempts as $i => $x) {
                $writer->startElementNs(null, 'failedAttempts', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XDimAttribute extends \Org\Apache\Lens\Api\Metastore\XField
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $startTime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $endTime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $numDistinctValues;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XChainColumn[]
     */
    private $chainRefColumn;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XDimAttributes
     */
    private $hierarchy;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $values;

    /**
     * Constructs a XDimAttribute from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getStartTime()
    {
        return $this->startTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $startTime
     */
    public function setStartTime($startTime)
    {
        $this->startTime = $startTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getEndTime()
    {
        return $this->endTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $endTime
     */
    public function setEndTime($endTime)
    {
        $this->endTime = $endTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getNumDistinctValues()
    {
        return $this->numDistinctValues;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $numDistinctValues
     */
    public function setNumDistinctValues($numDistinctValues)
    {
        $this->numDistinctValues = $numDistinctValues;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XChainColumn[]
     */
    public function getChainRefColumn()
    {
        return $this->chainRefColumn;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XChainColumn[] $chainRefColumn
     */
    public function setChainRefColumn($chainRefColumn)
    {
        $this->chainRefColumn = $chainRefColumn;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XDimAttributes
     */
    public function getHierarchy()
    {
        return $this->hierarchy;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XDimAttributes $hierarchy
     */
    public function setHierarchy($hierarchy)
    {
        $this->hierarchy = $hierarchy;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getValues()
    {
        return $this->values;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $values
     */
    public function setValues($values)
    {
        $this->values = $values;
    }

    /**
     * Sets a known child element of XDimAttribute from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'chain_ref_column') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XChainColumn($xml);
            if (!isset($this->chainRefColumn)) {
                $this->chainRefColumn = array();
            }
            array_push($this->chainRefColumn, $child);
            $happened = true;
        }
        else if (($xml->localName == 'hierarchy') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XDimAttributes($xml);
            $this->hierarchy = $child;
            $happened = true;
        }
        else if (($xml->localName == 'values') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->values)) {
                $this->values = array();
            }
            array_push($this->values, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XDimAttribute from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }
        else if (($xml->localName == '_type') && (empty($xml->namespaceURI))) {
            $this->type = $xml->value;
            return true;
        }
        else if (($xml->localName == 'start_time') && (empty($xml->namespaceURI))) {
            $this->startTime = $xml->value;
            return true;
        }
        else if (($xml->localName == 'end_time') && (empty($xml->namespaceURI))) {
            $this->endTime = $xml->value;
            return true;
        }
        else if (($xml->localName == 'num_distinct_values') && (empty($xml->namespaceURI))) {
            $this->numDistinctValues = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XDimAttribute to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->type) {
            $writer->writeAttribute('_type', $this->type);
        }
        if ($this->startTime) {
            $writer->writeAttribute('start_time', $this->startTime);
        }
        if ($this->endTime) {
            $writer->writeAttribute('end_time', $this->endTime);
        }
        if ($this->numDistinctValues) {
            $writer->writeAttribute('num_distinct_values', $this->numDistinctValues);
        }
        parent::writeXmlContents($writer);
        if ($this->chainRefColumn) {
            foreach ($this->chainRefColumn as $i => $x) {
                $writer->startElementNs('ns2', 'chain_ref_column', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->hierarchy) {
            $writer->startElementNs('ns2', 'hierarchy', null);
            $this->hierarchy->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->values) {
            foreach ($this->values as $i => $x) {
                $writer->startElementNs('ns2', 'values', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XDerivedCube extends \Org\Apache\Lens\Api\Metastore\XCube
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $parent;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XMeasureNames
     */
    private $measureNames;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XDimAttrNames
     */
    private $dimAttrNames;

    /**
     * Constructs a XDerivedCube from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * (no documentation provided)
     *
     * @param string $parent
     */
    public function setParent($parent)
    {
        $this->parent = $parent;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XMeasureNames
     */
    public function getMeasureNames()
    {
        return $this->measureNames;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XMeasureNames $measureNames
     */
    public function setMeasureNames($measureNames)
    {
        $this->measureNames = $measureNames;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XDimAttrNames
     */
    public function getDimAttrNames()
    {
        return $this->dimAttrNames;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XDimAttrNames $dimAttrNames
     */
    public function setDimAttrNames($dimAttrNames)
    {
        $this->dimAttrNames = $dimAttrNames;
    }

    /**
     * Sets a known child element of XDerivedCube from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'measure_names') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XMeasureNames($xml);
            $this->measureNames = $child;
            $happened = true;
        }
        else if (($xml->localName == 'dim_attr_names') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XDimAttrNames($xml);
            $this->dimAttrNames = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XDerivedCube from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }
        else if (($xml->localName == 'parent') && (empty($xml->namespaceURI))) {
            $this->parent = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XDerivedCube to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->parent) {
            $writer->writeAttribute('parent', $this->parent);
        }
        parent::writeXmlContents($writer);
        if ($this->measureNames) {
            $writer->startElementNs('ns2', 'measure_names', null);
            $this->measureNames->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->dimAttrNames) {
            $writer->startElementNs('ns2', 'dim_attr_names', null);
            $this->dimAttrNames->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class QueryCostType
{

    /**
     * 
     */
    const LOW = "LOW";

    /**
     * 
     */
    const MEDIUM = "MEDIUM";

    /**
     * 
     */
    const HIGH = "HIGH";
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XBaseCube extends \Org\Apache\Lens\Api\Metastore\XCube
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XMeasures
     */
    private $measures;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XDimAttributes
     */
    private $dimAttributes;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XExpressions
     */
    private $expressions;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XJoinChains
     */
    private $joinChains;

    /**
     * Constructs a XBaseCube from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XMeasures
     */
    public function getMeasures()
    {
        return $this->measures;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XMeasures $measures
     */
    public function setMeasures($measures)
    {
        $this->measures = $measures;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XDimAttributes
     */
    public function getDimAttributes()
    {
        return $this->dimAttributes;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XDimAttributes $dimAttributes
     */
    public function setDimAttributes($dimAttributes)
    {
        $this->dimAttributes = $dimAttributes;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XExpressions
     */
    public function getExpressions()
    {
        return $this->expressions;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XExpressions $expressions
     */
    public function setExpressions($expressions)
    {
        $this->expressions = $expressions;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XJoinChains
     */
    public function getJoinChains()
    {
        return $this->joinChains;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XJoinChains $joinChains
     */
    public function setJoinChains($joinChains)
    {
        $this->joinChains = $joinChains;
    }

    /**
     * Sets a known child element of XBaseCube from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'measures') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XMeasures($xml);
            $this->measures = $child;
            $happened = true;
        }
        else if (($xml->localName == 'dim_attributes') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XDimAttributes($xml);
            $this->dimAttributes = $child;
            $happened = true;
        }
        else if (($xml->localName == 'expressions') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XExpressions($xml);
            $this->expressions = $child;
            $happened = true;
        }
        else if (($xml->localName == 'join_chains') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XJoinChains($xml);
            $this->joinChains = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XBaseCube from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XBaseCube to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->measures) {
            $writer->startElementNs('ns2', 'measures', null);
            $this->measures->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->dimAttributes) {
            $writer->startElementNs('ns2', 'dim_attributes', null);
            $this->dimAttributes->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->expressions) {
            $writer->startElementNs('ns2', 'expressions', null);
            $this->expressions->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->joinChains) {
            $writer->startElementNs('ns2', 'join_chains', null);
            $this->joinChains->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api;

/**
 * (no documentation provided)
 */
class DateTime extends \Org\Apache\Lens\Api\ToYAMLString
{

    /**
     * The Date.
     *
     * @var integer
     */
    private $date;

    /**
     * Constructs a DateTime from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The Date.
     *
     * @return integer
     */
    public function getDate()
    {
        return $this->date;
    }

    /**
     * The Date.
     *
     * @param integer $date
     */
    public function setDate($date)
    {
        $this->date = $date;
    }

    /**
     * Sets a known child element of DateTime from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'date') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->date = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of DateTime from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this DateTime to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'dateTime', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this DateTime to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->date) {
            $writer->startElementNs(null, 'date', null);
            $writer->text($this->date);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class SchedulerJobInstanceState
{

    /**
     * 
     */
    const WAITING = "WAITING";

    /**
     * 
     */
    const LAUNCHING = "LAUNCHING";

    /**
     * 
     */
    const LAUNCHED = "LAUNCHED";

    /**
     * 
     */
    const RUNNING = "RUNNING";

    /**
     * 
     */
    const FAILED = "FAILED";

    /**
     * 
     */
    const SUCCEEDED = "SUCCEEDED";

    /**
     * 
     */
    const TIMED_OUT = "TIMED_OUT";

    /**
     * 
     */
    const KILLED = "KILLED";
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class XFrequencyEnum
{

    /**
     * 
     */
    const DAILY = "DAILY";

    /**
     * 
     */
    const WEEKLY = "WEEKLY";

    /**
     * 
     */
    const MONTHLY = "MONTHLY";

    /**
     * 
     */
    const QUARTERLY = "QUARTERLY";

    /**
     * 
     */
    const YEARLY = "YEARLY";
}

namespace Org\Apache\Lens\Api\Scheduler;

/**
 * (no documentation provided)
 */
class SchedulerJobState
{

    /**
     * 
     */
    const NEW = "NEW";

    /**
     * 
     */
    const SCHEDULED = "SCHEDULED";

    /**
     * 
     */
    const SUSPENDED = "SUSPENDED";

    /**
     * 
     */
    const EXPIRED = "EXPIRED";

    /**
     * 
     */
    const DELETED = "DELETED";
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class QueryResult extends \Org\Apache\Lens\Api\ToYAMLString
{

    /**
     * Constructs a QueryResult from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }


    /**
     * Sets a known child element of QueryResult from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of QueryResult from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this QueryResult to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'queryResult', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this QueryResult to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XVirtualFactTable extends \Org\Apache\Lens\Api\Metastore\XFact
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $sourceFactName;

    /**
     * (no documentation provided)
     *
     * @var double
     */
    private $weight;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XProperties
     */
    private $properties;

    /**
     * Constructs a XVirtualFactTable from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSourceFactName()
    {
        return $this->sourceFactName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $sourceFactName
     */
    public function setSourceFactName($sourceFactName)
    {
        $this->sourceFactName = $sourceFactName;
    }
    /**
     * (no documentation provided)
     *
     * @return double
     */
    public function getWeight()
    {
        return $this->weight;
    }

    /**
     * (no documentation provided)
     *
     * @param double $weight
     */
    public function setWeight($weight)
    {
        $this->weight = $weight;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XProperties
     */
    public function getProperties()
    {
        return $this->properties;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XProperties $properties
     */
    public function setProperties($properties)
    {
        $this->properties = $properties;
    }

    /**
     * Sets a known child element of XVirtualFactTable from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'properties') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XProperties($xml);
            $this->properties = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XVirtualFactTable from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }
        else if (($xml->localName == 'source_fact_name') && (empty($xml->namespaceURI))) {
            $this->sourceFactName = $xml->value;
            return true;
        }
        else if (($xml->localName == 'weight') && (empty($xml->namespaceURI))) {
            $this->weight = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XVirtualFactTable to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->sourceFactName) {
            $writer->writeAttribute('source_fact_name', $this->sourceFactName);
        }
        if ($this->weight) {
            $writer->writeAttribute('weight', $this->weight);
        }
        parent::writeXmlContents($writer);
        if ($this->properties) {
            $writer->startElementNs('ns2', 'properties', null);
            $this->properties->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XUpdatePeriod
{

    /**
     * 
     */
    const CONTINUOUS = "CONTINUOUS";

    /**
     * 
     */
    const SECONDLY = "SECONDLY";

    /**
     * 
     */
    const MINUTELY = "MINUTELY";

    /**
     * 
     */
    const HOURLY = "HOURLY";

    /**
     * 
     */
    const DAILY = "DAILY";

    /**
     * 
     */
    const WEEKLY = "WEEKLY";

    /**
     * 
     */
    const MONTHLY = "MONTHLY";

    /**
     * 
     */
    const QUARTERLY = "QUARTERLY";

    /**
     * 
     */
    const YEARLY = "YEARLY";
}

namespace Org\Apache\Lens\Api\Query\Save;

/**
 * (no documentation provided)
 */
class Action
{

    /**
     * Resource is created
     */
    const CREATED = "CREATED";

    /**
     * Resource is updated
     */
    const UPDATED = "UPDATED";

    /**
     * Resource is updated
     */
    const DELETED = "DELETED";
}

namespace Org\Apache\Lens\Api\Query\Save;

/**
 * (no documentation provided)
 */
class ParameterCollectionType
{

    /**
     * Single valued parameter.
     */
    const SINGLE = "SINGLE";

    /**
     * Multivalued parameter.
     */
    const MULTIPLE = "MULTIPLE";
}

namespace Org\Apache\Lens\Api\Query\Save;

/**
 * (no documentation provided)
 */
class ParameterDataType
{

    /**
     * String data type
     */
    const STRING = "STRING";

    /**
     * Number data type
     */
    const NUMBER = "NUMBER";

    /**
     * Decimal data type
     */
    const DECIMAL = "DECIMAL";

    /**
     * Boolean data type
     */
    const BOOLEAN = "BOOLEAN";
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class QueryStatus extends \Org\Apache\Lens\Api\ToYAMLString
{

    /**
     * The progress.
     *
     * @var double
     */
    private $progress;

    /**
     * The status.
     *
     * @var string
     */
    private $status;

    /**
     * The status message.
     *
     * @var string
     */
    private $statusMessage;

    /**
     * The is result set available.
     *
     * @var boolean
     */
    private $isResultSetAvailable;

    /**
     * Queue number of a query when it is in waiting state.
     *
     * @var integer
     */
    private $queueNumber;

    /**
     * The progress message.
     *
     * @var string
     */
    private $progressMessage;

    /**
     * The error message.
     *
     * @var string
     */
    private $errorMessage;

    /**
     * Constructs a QueryStatus from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The progress.
     *
     * @return double
     */
    public function getProgress()
    {
        return $this->progress;
    }

    /**
     * The progress.
     *
     * @param double $progress
     */
    public function setProgress($progress)
    {
        $this->progress = $progress;
    }
    /**
     * The status.
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * The status.
     *
     * @param string $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }
    /**
     * The status message.
     *
     * @return string
     */
    public function getStatusMessage()
    {
        return $this->statusMessage;
    }

    /**
     * The status message.
     *
     * @param string $statusMessage
     */
    public function setStatusMessage($statusMessage)
    {
        $this->statusMessage = $statusMessage;
    }
    /**
     * The is result set available.
     *
     * @return boolean
     */
    public function getIsResultSetAvailable()
    {
        return $this->isResultSetAvailable;
    }

    /**
     * The is result set available.
     *
     * @param boolean $isResultSetAvailable
     */
    public function setIsResultSetAvailable($isResultSetAvailable)
    {
        $this->isResultSetAvailable = $isResultSetAvailable;
    }
    /**
     * Queue number of a query when it is in waiting state.
     *
     * @return integer
     */
    public function getQueueNumber()
    {
        return $this->queueNumber;
    }

    /**
     * Queue number of a query when it is in waiting state.
     *
     * @param integer $queueNumber
     */
    public function setQueueNumber($queueNumber)
    {
        $this->queueNumber = $queueNumber;
    }
    /**
     * The progress message.
     *
     * @return string
     */
    public function getProgressMessage()
    {
        return $this->progressMessage;
    }

    /**
     * The progress message.
     *
     * @param string $progressMessage
     */
    public function setProgressMessage($progressMessage)
    {
        $this->progressMessage = $progressMessage;
    }
    /**
     * The error message.
     *
     * @return string
     */
    public function getErrorMessage()
    {
        return $this->errorMessage;
    }

    /**
     * The error message.
     *
     * @param string $errorMessage
     */
    public function setErrorMessage($errorMessage)
    {
        $this->errorMessage = $errorMessage;
    }

    /**
     * Sets a known child element of QueryStatus from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'progress') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->progress = $child;
            $happened = true;
        }
        else if (($xml->localName == 'status') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->status = $child;
            $happened = true;
        }
        else if (($xml->localName == 'statusMessage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->statusMessage = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isResultSetAvailable') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isResultSetAvailable = $child;
            $happened = true;
        }
        else if (($xml->localName == 'queueNumber') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->queueNumber = $child;
            $happened = true;
        }
        else if (($xml->localName == 'progressMessage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->progressMessage = $child;
            $happened = true;
        }
        else if (($xml->localName == 'errorMessage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->errorMessage = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of QueryStatus from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this QueryStatus to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'queryStatus', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this QueryStatus to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->progress) {
            $writer->startElementNs(null, 'progress', null);
            $writer->text($this->progress);
            $writer->endElement();
        }
        if ($this->status) {
            $writer->startElementNs(null, 'status', null);
            $writer->text($this->status);
            $writer->endElement();
        }
        if ($this->statusMessage) {
            $writer->startElementNs(null, 'statusMessage', null);
            $writer->text($this->statusMessage);
            $writer->endElement();
        }
        if ($this->isResultSetAvailable) {
            $writer->startElementNs(null, 'isResultSetAvailable', null);
            $writer->text($this->isResultSetAvailable);
            $writer->endElement();
        }
        if ($this->queueNumber) {
            $writer->startElementNs(null, 'queueNumber', null);
            $writer->text($this->queueNumber);
            $writer->endElement();
        }
        if ($this->progressMessage) {
            $writer->startElementNs(null, 'progressMessage', null);
            $writer->text($this->progressMessage);
            $writer->endElement();
        }
        if ($this->errorMessage) {
            $writer->startElementNs(null, 'errorMessage', null);
            $writer->text($this->errorMessage);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XMeasureType
{

    /**
     * 
     */
    const TINYINT = "TINYINT";

    /**
     * 
     */
    const SMALLINT = "SMALLINT";

    /**
     * 
     */
    const INT = "INT";

    /**
     * 
     */
    const BIGINT = "BIGINT";

    /**
     * 
     */
    const FLOAT = "FLOAT";

    /**
     * 
     */
    const DOUBLE = "DOUBLE";

    /**
     * 
     */
    const DECIMAL = "DECIMAL";
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XMeasure extends \Org\Apache\Lens\Api\Metastore\XField
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $defaultAggr;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $formatString;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $startTime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $endTime;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $unit;

    /**
     * (no documentation provided)
     *
     * @var double
     */
    private $min;

    /**
     * (no documentation provided)
     *
     * @var double
     */
    private $max;

    /**
     * Constructs a XMeasure from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDefaultAggr()
    {
        return $this->defaultAggr;
    }

    /**
     * (no documentation provided)
     *
     * @param string $defaultAggr
     */
    public function setDefaultAggr($defaultAggr)
    {
        $this->defaultAggr = $defaultAggr;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getFormatString()
    {
        return $this->formatString;
    }

    /**
     * (no documentation provided)
     *
     * @param string $formatString
     */
    public function setFormatString($formatString)
    {
        $this->formatString = $formatString;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getStartTime()
    {
        return $this->startTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $startTime
     */
    public function setStartTime($startTime)
    {
        $this->startTime = $startTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getEndTime()
    {
        return $this->endTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $endTime
     */
    public function setEndTime($endTime)
    {
        $this->endTime = $endTime;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUnit()
    {
        return $this->unit;
    }

    /**
     * (no documentation provided)
     *
     * @param string $unit
     */
    public function setUnit($unit)
    {
        $this->unit = $unit;
    }
    /**
     * (no documentation provided)
     *
     * @return double
     */
    public function getMin()
    {
        return $this->min;
    }

    /**
     * (no documentation provided)
     *
     * @param double $min
     */
    public function setMin($min)
    {
        $this->min = $min;
    }
    /**
     * (no documentation provided)
     *
     * @return double
     */
    public function getMax()
    {
        return $this->max;
    }

    /**
     * (no documentation provided)
     *
     * @param double $max
     */
    public function setMax($max)
    {
        $this->max = $max;
    }

    /**
     * Sets a known child element of XMeasure from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of XMeasure from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }
        else if (($xml->localName == '_type') && (empty($xml->namespaceURI))) {
            $this->type = $xml->value;
            return true;
        }
        else if (($xml->localName == 'default_aggr') && (empty($xml->namespaceURI))) {
            $this->defaultAggr = $xml->value;
            return true;
        }
        else if (($xml->localName == 'format_string') && (empty($xml->namespaceURI))) {
            $this->formatString = $xml->value;
            return true;
        }
        else if (($xml->localName == 'start_time') && (empty($xml->namespaceURI))) {
            $this->startTime = $xml->value;
            return true;
        }
        else if (($xml->localName == 'end_time') && (empty($xml->namespaceURI))) {
            $this->endTime = $xml->value;
            return true;
        }
        else if (($xml->localName == 'unit') && (empty($xml->namespaceURI))) {
            $this->unit = $xml->value;
            return true;
        }
        else if (($xml->localName == 'min') && (empty($xml->namespaceURI))) {
            $this->min = $xml->value;
            return true;
        }
        else if (($xml->localName == 'max') && (empty($xml->namespaceURI))) {
            $this->max = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XMeasure to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->type) {
            $writer->writeAttribute('_type', $this->type);
        }
        if ($this->defaultAggr) {
            $writer->writeAttribute('default_aggr', $this->defaultAggr);
        }
        if ($this->formatString) {
            $writer->writeAttribute('format_string', $this->formatString);
        }
        if ($this->startTime) {
            $writer->writeAttribute('start_time', $this->startTime);
        }
        if ($this->endTime) {
            $writer->writeAttribute('end_time', $this->endTime);
        }
        if ($this->unit) {
            $writer->writeAttribute('unit', $this->unit);
        }
        if ($this->min) {
            $writer->writeAttribute('min', $this->min);
        }
        if ($this->max) {
            $writer->writeAttribute('max', $this->max);
        }
        parent::writeXmlContents($writer);
    }
}

namespace Org\Apache\Lens\Api\Metastore;

/**
 * (no documentation provided)
 */
class XJoinChain extends \Org\Apache\Lens\Api\Metastore\XField
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $destTable;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Lens\Api\Metastore\XJoinPaths
     */
    private $paths;

    /**
     * Constructs a XJoinChain from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDestTable()
    {
        return $this->destTable;
    }

    /**
     * (no documentation provided)
     *
     * @param string $destTable
     */
    public function setDestTable($destTable)
    {
        $this->destTable = $destTable;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Lens\Api\Metastore\XJoinPaths
     */
    public function getPaths()
    {
        return $this->paths;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Lens\Api\Metastore\XJoinPaths $paths
     */
    public function setPaths($paths)
    {
        $this->paths = $paths;
    }

    /**
     * Sets a known child element of XJoinChain from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'paths') && ($xml->namespaceURI == 'uri:lens:cube:0.1')) {
            $child = new \Org\Apache\Lens\Api\Metastore\XJoinPaths($xml);
            $this->paths = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of XJoinChain from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }
        else if (($xml->localName == 'dest_table') && (empty($xml->namespaceURI))) {
            $this->destTable = $xml->value;
            return true;
        }

        return false;
    }

    /**
     * Writes the contents of this XJoinChain to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->destTable) {
            $writer->writeAttribute('dest_table', $this->destTable);
        }
        parent::writeXmlContents($writer);
        if ($this->paths) {
            $writer->startElementNs('ns2', 'paths', null);
            $this->paths->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class ResultColumnType
{

    /**
     * The boolean.
     */
    const BOOLEAN = "BOOLEAN";

    /**
     * The tinyint.
     */
    const TINYINT = "TINYINT";

    /**
     * The smallint.
     */
    const SMALLINT = "SMALLINT";

    /**
     * The int.
     */
    const INT = "INT";

    /**
     * The bigint.
     */
    const BIGINT = "BIGINT";

    /**
     * The float.
     */
    const FLOAT = "FLOAT";

    /**
     * The double.
     */
    const DOUBLE = "DOUBLE";

    /**
     * The string.
     */
    const STRING = "STRING";

    /**
     * The timestamp.
     */
    const TIMESTAMP = "TIMESTAMP";

    /**
     * The binary.
     */
    const BINARY = "BINARY";

    /**
     * The array.
     */
    const ARRAY = "ARRAY";

    /**
     * The map.
     */
    const MAP = "MAP";

    /**
     * The struct.
     */
    const STRUCT = "STRUCT";

    /**
     * The uniontype.
     */
    const UNIONTYPE = "UNIONTYPE";

    /**
     * The user defined.
     */
    const USER_DEFINED = "USER_DEFINED";

    /**
     * The decimal.
     */
    const DECIMAL = "DECIMAL";

    /**
     * The null.
     */
    const NULL = "NULL";

    /**
     * The date.
     */
    const DATE = "DATE";

    /**
     * The varchar.
     */
    const VARCHAR = "VARCHAR";

    /**
     * The char.
     */
    const CHAR = "CHAR";
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class QuerySubmitResult extends \Org\Apache\Lens\Api\ToYAMLString
{

    /**
     * Constructs a QuerySubmitResult from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }


    /**
     * Sets a known child element of QuerySubmitResult from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of QuerySubmitResult from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this QuerySubmitResult to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'querySubmitResult', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this QuerySubmitResult to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class Status
{

    /**
     * The new.
     */
    const NEW = "NEW";

    /**
     * The queued.
    * At this point the query is queued by the server and it waiting to be launched. The launch may be controlled by
    * multiple factors like query throttling, quota, etc
     */
    const QUEUED = "QUEUED";

    /**
     * The launched.
    * At this point the query is launched for execution.
     */
    const LAUNCHED = "LAUNCHED";

    /**
     * The running.
    * At this point the query starts running on chosen driver
     */
    const RUNNING = "RUNNING";

    /**
     * The executed.
    * At this point execution is finished by driver, but server may still have some more operations pending
    * like result persistence, if enabled.
     */
    const EXECUTED = "EXECUTED";

    /**
     * This state is when depending on retry policy, either the query moves to QUEUED (in case retries are to be done),
    * or to FAILED.
     */
    const FAILING = "FAILING";

    /**
     * The successful.
    * At this point all operations related to the query are finished successfully by driver and server.
     */
    const SUCCESSFUL = "SUCCESSFUL";

    /**
     * The failed.
     */
    const FAILED = "FAILED";

    /**
     * The canceled.
     */
    const CANCELED = "CANCELED";

    /**
     * The closed.
    * At this point the query is purged by the server. Persistent result will still be available to the user
     */
    const CLOSED = "CLOSED";
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class QueryResultSetMetadata extends \Org\Apache\Lens\Api\ToYAMLString
{

    /**
     * The columns.
     *
     * @var \Org\Apache\Lens\Api\Query\ResultColumn[]
     */
    private $columns;

    /**
     * Constructs a QueryResultSetMetadata from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The columns.
     *
     * @return \Org\Apache\Lens\Api\Query\ResultColumn[]
     */
    public function getColumns()
    {
        return $this->columns;
    }

    /**
     * The columns.
     *
     * @param \Org\Apache\Lens\Api\Query\ResultColumn[] $columns
     */
    public function setColumns($columns)
    {
        $this->columns = $columns;
    }

    /**
     * Sets a known child element of QueryResultSetMetadata from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'columns') && (empty($xml->namespaceURI)) && (!$xml->isEmptyElement)) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc. in the wrapper
                }
        if (($xml->localName == 'columns') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\ResultColumn($xml);
            if (!isset($this->columns)) {
                $this->columns = array();
            }
            array_push($this->columns, $child);
            $happened = true;
        }
                $xml->read();
            }
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of QueryResultSetMetadata from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this QueryResultSetMetadata to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'queryResultSetMetadata', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this QueryResultSetMetadata to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->columns) {
            $writer->startElementNs(null, 'columns', null);
            foreach ($this->columns as $i => $x) {
                $writer->startElementNs(null, 'columns', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api;

/**
 * (no documentation provided)
 */
class LensSessionHandle extends \Org\Apache\Lens\Api\ToXMLString
{

    /**
     * The public id.
     *
     * @var string
     */
    private $publicId;

    /**
     * The secret id.
     *
     * @var string
     */
    private $secretId;

    /**
     * Constructs a LensSessionHandle from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The public id.
     *
     * @return string
     */
    public function getPublicId()
    {
        return $this->publicId;
    }

    /**
     * The public id.
     *
     * @param string $publicId
     */
    public function setPublicId($publicId)
    {
        $this->publicId = $publicId;
    }
    /**
     * The secret id.
     *
     * @return string
     */
    public function getSecretId()
    {
        return $this->secretId;
    }

    /**
     * The secret id.
     *
     * @param string $secretId
     */
    public function setSecretId($secretId)
    {
        $this->secretId = $secretId;
    }

    /**
     * Sets a known child element of LensSessionHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'publicId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->publicId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'secretId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->secretId = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of LensSessionHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this LensSessionHandle to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'lensSessionHandle', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this LensSessionHandle to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->publicId) {
            $writer->startElementNs(null, 'publicId', null);
            $writer->text($this->publicId);
            $writer->endElement();
        }
        if ($this->secretId) {
            $writer->startElementNs(null, 'secretId', null);
            $writer->text($this->secretId);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api;

/**
 * (no documentation provided)
 */
class Priority
{

    /**
     * The very high.
     */
    const VERY_HIGH = "VERY_HIGH";

    /**
     * The high.
     */
    const HIGH = "HIGH";

    /**
     * The normal.
     */
    const NORMAL = "NORMAL";

    /**
     * The low.
     */
    const LOW = "LOW";

    /**
     * The very low.
     */
    const VERY_LOW = "VERY_LOW";
}

namespace Org\Apache\Lens\Api;

/**
 * (no documentation provided)
 */
class LensConf extends \Org\Apache\Lens\Api\ToYAMLString
{

    /**
     * The properties.
     *
     * @var array
     */
    private $properties;

    /**
     * Constructs a LensConf from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The properties.
     *
     * @return array
     */
    public function getProperties()
    {
        return $this->properties;
    }

    /**
     * The properties.
     *
     * @param array $properties
     */
    public function setProperties($properties)
    {
        $this->properties = $properties;
    }

    /**
     * Sets a known child element of LensConf from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'properties') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->properties = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of LensConf from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this LensConf to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'conf', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this LensConf to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->properties) {
            $writer->startElementNs(null, 'properties', null);
            $writer->text($this->properties);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api;

/**
 * (no documentation provided)
 */
class Status
{

    /**
     * The succeeded.
     */
    const SUCCEEDED = "SUCCEEDED";

    /**
     * The partial.
     */
    const PARTIAL = "PARTIAL";

    /**
     * The failed.
     */
    const FAILED = "FAILED";
}

namespace Org\Apache\Lens\Api;

/**
 * (no documentation provided)
 */
class APIResult extends \Org\Apache\Lens\Api\ToYAMLString
{

    /**
     * The status.
     *
     * @var string
     */
    private $status;

    /**
     * The message.
     *
     * @var string
     */
    private $message;

    /**
     * Constructs a APIResult from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The status.
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * The status.
     *
     * @param string $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }
    /**
     * The message.
     *
     * @return string
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * The message.
     *
     * @param string $message
     */
    public function setMessage($message)
    {
        $this->message = $message;
    }

    /**
     * Sets a known child element of APIResult from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'status') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->status = $child;
            $happened = true;
        }
        else if (($xml->localName == 'message') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->message = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of APIResult from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this APIResult to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'APIResult', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this APIResult to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->status) {
            $writer->startElementNs(null, 'status', null);
            $writer->text($this->status);
            $writer->endElement();
        }
        if ($this->message) {
            $writer->startElementNs(null, 'message', null);
            $writer->text($this->message);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Result;

/**
 * (no documentation provided)
 */
class QueryCostTO extends \Org\Apache\Lens\Api\Query\QuerySubmitResult
{

    /**
     * The estimated exec time millis.
     *
     * @var integer
     */
    private $estimatedExecTimeMillis;

    /**
     * The estimated resource usage.
     *
     * @var double
     */
    private $estimatedResourceUsage;

    /**
     * Normalized query cost, calculated by driver
     *
     * @var string
     */
    private $costType;

    /**
     * Constructs a QueryCostTO from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The estimated exec time millis.
     *
     * @return integer
     */
    public function getEstimatedExecTimeMillis()
    {
        return $this->estimatedExecTimeMillis;
    }

    /**
     * The estimated exec time millis.
     *
     * @param integer $estimatedExecTimeMillis
     */
    public function setEstimatedExecTimeMillis($estimatedExecTimeMillis)
    {
        $this->estimatedExecTimeMillis = $estimatedExecTimeMillis;
    }
    /**
     * The estimated resource usage.
     *
     * @return double
     */
    public function getEstimatedResourceUsage()
    {
        return $this->estimatedResourceUsage;
    }

    /**
     * The estimated resource usage.
     *
     * @param double $estimatedResourceUsage
     */
    public function setEstimatedResourceUsage($estimatedResourceUsage)
    {
        $this->estimatedResourceUsage = $estimatedResourceUsage;
    }
    /**
     * Normalized query cost, calculated by driver
     *
     * @return string
     */
    public function getCostType()
    {
        return $this->costType;
    }

    /**
     * Normalized query cost, calculated by driver
     *
     * @param string $costType
     */
    public function setCostType($costType)
    {
        $this->costType = $costType;
    }

    /**
     * Sets a known child element of QueryCostTO from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'estimatedExecTimeMillis') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->estimatedExecTimeMillis = $child;
            $happened = true;
        }
        else if (($xml->localName == 'estimatedResourceUsage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->estimatedResourceUsage = $child;
            $happened = true;
        }
        else if (($xml->localName == 'costType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->costType = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of QueryCostTO from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this QueryCostTO to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'queryCostTO', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this QueryCostTO to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->estimatedExecTimeMillis) {
            $writer->startElementNs(null, 'estimatedExecTimeMillis', null);
            $writer->text($this->estimatedExecTimeMillis);
            $writer->endElement();
        }
        if ($this->estimatedResourceUsage) {
            $writer->startElementNs(null, 'estimatedResourceUsage', null);
            $writer->text($this->estimatedResourceUsage);
            $writer->endElement();
        }
        if ($this->costType) {
            $writer->startElementNs(null, 'costType', null);
            $writer->text($this->costType);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class QueryPrepareHandle extends \Org\Apache\Lens\Api\Query\QuerySubmitResult
{

    /**
     * The prepare handle id.
     *
     * @var string
     */
    private $prepareHandleId;

    /**
     * Constructs a QueryPrepareHandle from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The prepare handle id.
     *
     * @return string
     */
    public function getPrepareHandleId()
    {
        return $this->prepareHandleId;
    }

    /**
     * The prepare handle id.
     *
     * @param string $prepareHandleId
     */
    public function setPrepareHandleId($prepareHandleId)
    {
        $this->prepareHandleId = $prepareHandleId;
    }

    /**
     * Sets a known child element of QueryPrepareHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'prepareHandleId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->prepareHandleId = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of QueryPrepareHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this QueryPrepareHandle to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'queryPrepareHandle', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this QueryPrepareHandle to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->prepareHandleId) {
            $writer->startElementNs(null, 'prepareHandleId', null);
            $writer->text($this->prepareHandleId);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class QueryHandleWithResultSet extends \Org\Apache\Lens\Api\Query\QuerySubmitResult
{

    /**
     * The query handle.
     *
     * @var \Org\Apache\Lens\Api\Query\QueryHandle
     */
    private $queryHandle;

    /**
     * The result.
     *
     * @var \Org\Apache\Lens\Api\Query\QueryResult
     */
    private $result;

    /**
     * The result metadata
     *
     * @var \Org\Apache\Lens\Api\Query\QueryResultSetMetadata
     */
    private $resultMetadata;

    /**
     * The status.
     *
     * @var \Org\Apache\Lens\Api\Query\QueryStatus
     */
    private $status;

    /**
     * Constructs a QueryHandleWithResultSet from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The query handle.
     *
     * @return \Org\Apache\Lens\Api\Query\QueryHandle
     */
    public function getQueryHandle()
    {
        return $this->queryHandle;
    }

    /**
     * The query handle.
     *
     * @param \Org\Apache\Lens\Api\Query\QueryHandle $queryHandle
     */
    public function setQueryHandle($queryHandle)
    {
        $this->queryHandle = $queryHandle;
    }
    /**
     * The result.
     *
     * @return \Org\Apache\Lens\Api\Query\QueryResult
     */
    public function getResult()
    {
        return $this->result;
    }

    /**
     * The result.
     *
     * @param \Org\Apache\Lens\Api\Query\QueryResult $result
     */
    public function setResult($result)
    {
        $this->result = $result;
    }
    /**
     * The result metadata
     *
     * @return \Org\Apache\Lens\Api\Query\QueryResultSetMetadata
     */
    public function getResultMetadata()
    {
        return $this->resultMetadata;
    }

    /**
     * The result metadata
     *
     * @param \Org\Apache\Lens\Api\Query\QueryResultSetMetadata $resultMetadata
     */
    public function setResultMetadata($resultMetadata)
    {
        $this->resultMetadata = $resultMetadata;
    }
    /**
     * The status.
     *
     * @return \Org\Apache\Lens\Api\Query\QueryStatus
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * The status.
     *
     * @param \Org\Apache\Lens\Api\Query\QueryStatus $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }

    /**
     * Sets a known child element of QueryHandleWithResultSet from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'queryHandle') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\QueryHandle($xml);
            $this->queryHandle = $child;
            $happened = true;
        }
        else if (($xml->localName == 'result') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\QueryResult($xml);
            $this->result = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resultMetadata') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\QueryResultSetMetadata($xml);
            $this->resultMetadata = $child;
            $happened = true;
        }
        else if (($xml->localName == 'status') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\QueryStatus($xml);
            $this->status = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of QueryHandleWithResultSet from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this QueryHandleWithResultSet to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'queryHandleWithResultSet', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this QueryHandleWithResultSet to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->queryHandle) {
            $writer->startElementNs(null, 'queryHandle', null);
            $this->queryHandle->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->result) {
            $writer->startElementNs(null, 'result', null);
            $this->result->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->resultMetadata) {
            $writer->startElementNs(null, 'resultMetadata', null);
            $this->resultMetadata->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->status) {
            $writer->startElementNs(null, 'status', null);
            $this->status->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class QueryPlan extends \Org\Apache\Lens\Api\Query\QuerySubmitResult
{

    /**
     * The tables queried.
     *
     * @var string[]
     */
    private $tablesQueried;

    /**
     * The has sub query.
     *
     * @var boolean
     */
    private $hasSubQuery;

    /**
     * The exec mode.
     *
     * @var string
     */
    private $execMode;

    /**
     * The scan mode.
     *
     * @var string
     */
    private $scanMode;

    /**
     * The plan string.
     *
     * @var string
     */
    private $planString;

    /**
     * The query cost.
     *
     * @var \Org\Apache\Lens\Api\Result\QueryCostTO
     */
    private $queryCost;

    /**
     * The prepare handle.
     *
     * @var \Org\Apache\Lens\Api\Query\QueryPrepareHandle
     */
    private $prepareHandle;

    /**
     * Constructs a QueryPlan from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The tables queried.
     *
     * @return string[]
     */
    public function getTablesQueried()
    {
        return $this->tablesQueried;
    }

    /**
     * The tables queried.
     *
     * @param string[] $tablesQueried
     */
    public function setTablesQueried($tablesQueried)
    {
        $this->tablesQueried = $tablesQueried;
    }
    /**
     * The has sub query.
     *
     * @return boolean
     */
    public function getHasSubQuery()
    {
        return $this->hasSubQuery;
    }

    /**
     * The has sub query.
     *
     * @param boolean $hasSubQuery
     */
    public function setHasSubQuery($hasSubQuery)
    {
        $this->hasSubQuery = $hasSubQuery;
    }
    /**
     * The exec mode.
     *
     * @return string
     */
    public function getExecMode()
    {
        return $this->execMode;
    }

    /**
     * The exec mode.
     *
     * @param string $execMode
     */
    public function setExecMode($execMode)
    {
        $this->execMode = $execMode;
    }
    /**
     * The scan mode.
     *
     * @return string
     */
    public function getScanMode()
    {
        return $this->scanMode;
    }

    /**
     * The scan mode.
     *
     * @param string $scanMode
     */
    public function setScanMode($scanMode)
    {
        $this->scanMode = $scanMode;
    }
    /**
     * The plan string.
     *
     * @return string
     */
    public function getPlanString()
    {
        return $this->planString;
    }

    /**
     * The plan string.
     *
     * @param string $planString
     */
    public function setPlanString($planString)
    {
        $this->planString = $planString;
    }
    /**
     * The query cost.
     *
     * @return \Org\Apache\Lens\Api\Result\QueryCostTO
     */
    public function getQueryCost()
    {
        return $this->queryCost;
    }

    /**
     * The query cost.
     *
     * @param \Org\Apache\Lens\Api\Result\QueryCostTO $queryCost
     */
    public function setQueryCost($queryCost)
    {
        $this->queryCost = $queryCost;
    }
    /**
     * The prepare handle.
     *
     * @return \Org\Apache\Lens\Api\Query\QueryPrepareHandle
     */
    public function getPrepareHandle()
    {
        return $this->prepareHandle;
    }

    /**
     * The prepare handle.
     *
     * @param \Org\Apache\Lens\Api\Query\QueryPrepareHandle $prepareHandle
     */
    public function setPrepareHandle($prepareHandle)
    {
        $this->prepareHandle = $prepareHandle;
    }

    /**
     * Sets a known child element of QueryPlan from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'tablesQueried') && (empty($xml->namespaceURI)) && (!$xml->isEmptyElement)) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc. in the wrapper
                }
        if (($xml->localName == 'tablesQueried') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->tablesQueried)) {
                $this->tablesQueried = array();
            }
            array_push($this->tablesQueried, $child);
            $happened = true;
        }
                $xml->read();
            }
            $happened = true;
        }
        else if (($xml->localName == 'hasSubQuery') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->hasSubQuery = $child;
            $happened = true;
        }
        else if (($xml->localName == 'execMode') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->execMode = $child;
            $happened = true;
        }
        else if (($xml->localName == 'scanMode') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->scanMode = $child;
            $happened = true;
        }
        else if (($xml->localName == 'planString') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->planString = $child;
            $happened = true;
        }
        else if (($xml->localName == 'queryCost') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Result\QueryCostTO($xml);
            $this->queryCost = $child;
            $happened = true;
        }
        else if (($xml->localName == 'prepareHandle') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\QueryPrepareHandle($xml);
            $this->prepareHandle = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of QueryPlan from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this QueryPlan to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'queryPlan', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this QueryPlan to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->tablesQueried) {
            $writer->startElementNs(null, 'tablesQueried', null);
            foreach ($this->tablesQueried as $i => $x) {
                $writer->startElementNs(null, 'tablesQueried', null);
                $writer->text($x);
                $writer->endElement();
            }
            $writer->endElement();
        }
        if ($this->hasSubQuery) {
            $writer->startElementNs(null, 'hasSubQuery', null);
            $writer->text($this->hasSubQuery);
            $writer->endElement();
        }
        if ($this->execMode) {
            $writer->startElementNs(null, 'execMode', null);
            $writer->text($this->execMode);
            $writer->endElement();
        }
        if ($this->scanMode) {
            $writer->startElementNs(null, 'scanMode', null);
            $writer->text($this->scanMode);
            $writer->endElement();
        }
        if ($this->planString) {
            $writer->startElementNs(null, 'planString', null);
            $writer->text($this->planString);
            $writer->endElement();
        }
        if ($this->queryCost) {
            $writer->startElementNs(null, 'queryCost', null);
            $this->queryCost->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->prepareHandle) {
            $writer->startElementNs(null, 'prepareHandle', null);
            $this->prepareHandle->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class QueryHandle extends \Org\Apache\Lens\Api\Query\QuerySubmitResult
{

    /**
     * The handle id.
     *
     * @var string
     */
    private $handleId;

    /**
     * Constructs a QueryHandle from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The handle id.
     *
     * @return string
     */
    public function getHandleId()
    {
        return $this->handleId;
    }

    /**
     * The handle id.
     *
     * @param string $handleId
     */
    public function setHandleId($handleId)
    {
        $this->handleId = $handleId;
    }

    /**
     * Sets a known child element of QueryHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'handleId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->handleId = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of QueryHandle from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this QueryHandle to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'queryHandle', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this QueryHandle to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->handleId) {
            $writer->startElementNs(null, 'handleId', null);
            $writer->text($this->handleId);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class PersistentQueryResult extends \Org\Apache\Lens\Api\Query\QueryResult
{

    /**
     * The persisted uri.
     *
     * @var string
     */
    private $persistedURI;

    /**
     * The num rows.
     *
     * @var integer
     */
    private $numRows;

    /**
     * The file size.
     *
     * @var integer
     */
    private $fileSize;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $httpResultUrl;

    /**
     * Constructs a PersistentQueryResult from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The persisted uri.
     *
     * @return string
     */
    public function getPersistedURI()
    {
        return $this->persistedURI;
    }

    /**
     * The persisted uri.
     *
     * @param string $persistedURI
     */
    public function setPersistedURI($persistedURI)
    {
        $this->persistedURI = $persistedURI;
    }
    /**
     * The num rows.
     *
     * @return integer
     */
    public function getNumRows()
    {
        return $this->numRows;
    }

    /**
     * The num rows.
     *
     * @param integer $numRows
     */
    public function setNumRows($numRows)
    {
        $this->numRows = $numRows;
    }
    /**
     * The file size.
     *
     * @return integer
     */
    public function getFileSize()
    {
        return $this->fileSize;
    }

    /**
     * The file size.
     *
     * @param integer $fileSize
     */
    public function setFileSize($fileSize)
    {
        $this->fileSize = $fileSize;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getHttpResultUrl()
    {
        return $this->httpResultUrl;
    }

    /**
     * (no documentation provided)
     *
     * @param string $httpResultUrl
     */
    public function setHttpResultUrl($httpResultUrl)
    {
        $this->httpResultUrl = $httpResultUrl;
    }

    /**
     * Sets a known child element of PersistentQueryResult from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'persistedURI') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->persistedURI = $child;
            $happened = true;
        }
        else if (($xml->localName == 'numRows') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->numRows = $child;
            $happened = true;
        }
        else if (($xml->localName == 'fileSize') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->fileSize = $child;
            $happened = true;
        }
        else if (($xml->localName == 'httpResultUrl') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->httpResultUrl = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of PersistentQueryResult from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this PersistentQueryResult to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'persistentQueryResult', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this PersistentQueryResult to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->persistedURI) {
            $writer->startElementNs(null, 'persistedURI', null);
            $writer->text($this->persistedURI);
            $writer->endElement();
        }
        if ($this->numRows) {
            $writer->startElementNs(null, 'numRows', null);
            $writer->text($this->numRows);
            $writer->endElement();
        }
        if ($this->fileSize) {
            $writer->startElementNs(null, 'fileSize', null);
            $writer->text($this->fileSize);
            $writer->endElement();
        }
        if ($this->httpResultUrl) {
            $writer->startElementNs(null, 'httpResultUrl', null);
            $writer->text($this->httpResultUrl);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Lens\Api\Query;

/**
 * (no documentation provided)
 */
class InMemoryQueryResult extends \Org\Apache\Lens\Api\Query\QueryResult
{

    /**
     * The rows.
     *
     * @var \Org\Apache\Lens\Api\Query\ResultRow[]
     */
    private $rows;

    /**
     * Constructs a InMemoryQueryResult from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * The rows.
     *
     * @return \Org\Apache\Lens\Api\Query\ResultRow[]
     */
    public function getRows()
    {
        return $this->rows;
    }

    /**
     * The rows.
     *
     * @param \Org\Apache\Lens\Api\Query\ResultRow[] $rows
     */
    public function setRows($rows)
    {
        $this->rows = $rows;
    }

    /**
     * Sets a known child element of InMemoryQueryResult from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'rows') && (empty($xml->namespaceURI)) && (!$xml->isEmptyElement)) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc. in the wrapper
                }
        if (($xml->localName == 'rows') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Lens\Api\Query\ResultRow($xml);
            if (!isset($this->rows)) {
                $this->rows = array();
            }
            array_push($this->rows, $child);
            $happened = true;
        }
                $xml->read();
            }
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of InMemoryQueryResult from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this InMemoryQueryResult to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'inMemoryQueryResult', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this InMemoryQueryResult to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->rows) {
            $writer->startElementNs(null, 'rows', null);
            foreach ($this->rows as $i => $x) {
                $writer->startElementNs(null, 'rows', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
            $writer->endElement();
        }
    }
}
